; adaba.nsi
;
; this script has been partially generated by the HM NIS Edit Script Wizard
; the rest is stolen from the internet and homebrewn.

;--------------------------------

;!define PRODUCT_LONGNAME "sterreichische Aussprachedatenbank"
!define PRODUCT_LONGNAME "adaba"
!define PRODUCT_NAME "adaba"


; -------- more variables ----------
Var OPTIONS
; the directory we copy data from: usually ${EXEDIR}
Var DATASOURCEDIR
; whether we want to delete all data on uninstallation
Var UNINST_DELDATA



; ------- includes and macrodefinitions ----------
!include FileFunc.nsh
!insertmacro GetOptions
!insertmacro GetParameters

!include "MUI.nsh"

!include "java.nsi"


; FONTS
; see http://nsis.sourceforge.net/Register_Fonts
; and http://nsis.sourceforge.net/Advanced_Font_Installation
; and http://nsis.sourceforge.net/FontName_plug-in
; probably there is something simpler!

!include FontRegAdv.nsh
!include FontName.nsh


!include Sections.nsh



; HM NIS Edit Wizard helper defines



!ifndef PRODUCT_VERSION
 !ifndef PRODUCT_BASEVERSION
  !define PRODUCT_BASEVERSION "0.99-beta"
 !endif
 !ifdef PRODUCT_BUILDVERSION
  !define PRODUCT_VERSION "${PRODUCT_BASEVERSION} (r${PRODUCT_BUILDVERSION})"
 !else
  !define PRODUCT_VERSION "${PRODUCT_BASEVERSION}"
 !endif
!endif
!define PRODUCT_PUBLISHER "IOhannes m zmlnig"
!define PRODUCT_WEB_SITE "http://adaba.iem.at"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_STARTMENU_REGVAL "NSIS:StartMenuDir"

!define PRODUCT_REGISTRY_PREF "Software\JavaSoft\Prefs\${PRODUCT_NAME}"

; MUI 1.67 compatible ------


; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Language Selection Dialog Settings
!define MUI_LANGDLL_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_LANGDLL_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_LANGDLL_REGISTRY_VALUENAME "NSIS:Language"


; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!insertmacro MUI_PAGE_LICENSE "..\resources\licenses\LICENSE.txt"
; Components page
!insertmacro MUI_PAGE_COMPONENTS


Page Custom InstallDatadir_set InstallDatadir_validate

; Directory page
!insertmacro MUI_PAGE_DIRECTORY



; Start menu page
var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "adaba"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT_STARTMENU_REGVAL}"
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_RUN "$INSTDIR\adaba.exe"
;!define MUI_FINISHPAGE_RUN_PARAMETERS "-Xms128m -Xmx240m -jar $INSTDIR\Adaba.jar"
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\Readme.html"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "German"

; MUI end ------



; The name of the installer
Name "${PRODUCT_LONGNAME} ${PRODUCT_VERSION}"
OutFile "..\setup.exe"
InstallDir "$PROGRAMFILES\adaba"
;InstallDir C:\home\zmoelnig\adaba

ShowInstDetails show
ShowUnInstDetails show

;--------------------------------
; Functions

/*
Function EnsureAdministrator
        ClearErrors
        UserInfo::GetName
        IfErrors iAmAdmin
        Pop $0
        UserInfo::GetAccountType
        Pop $1
        StrCmp $1 "Admin" 0 +3
;                MessageBox MB_OK 'User "$0" is in the Administrators group'
                Goto iAmAdmin

        MessageBox MB_OK 'you "$0" have to be in the Administrators group to install things'
	Quit


	iAmAdmin:
                MessageBox MB_OK 'User "$0" is in the Administrators group'
FunctionEnd
*/


Function ReinstallAdaba
	# this depends on the messagebox plugin found at http://nsis.sourceforge.net/MessageBox_plug-in
	messagebox::show MB_DEFBUTTON4|MB_TOPMOST|MB_ICONEXCLAMATION "adaba already installed." "0,1" \
	"adaba ist bereits auf Ihrem Computer installiert.$\nSie knnen entweder adaba ausfhren, aktualisieren oder von Ihrer Festplatte deinstallieren.$\nTreffen Sie Ihre Wahl!" \
	"Ausfhren" "Aktualisieren" "Deinstallieren" "IDCANCEL"

	Pop $0

	StrCmp $0 "1" try_run
	StrCmp $0 "2" try_update
	StrCmp $0 "3" try_uninstall

	Quit

 try_run:
;        MessageBox MB_OK "you selected to run adaba"
	ReadRegStr $2 HKLM "${PRODUCT_REGISTRY_PREF}" "ApplicationPath"

        IfFileExists $2\adaba.exe 0 run_javaw
	Exec '"$2"\adaba.exe'
	Quit
  
 run_javaw:
	Exec 'javaw -Xms128m -Xmx240m -jar "$2"\Adaba.jar'
	Quit

 try_uninstall:
;        MessageBox MB_OK "you selected to uninstall adaba"
	ReadRegStr $2 ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString"
	Exec "$2"
	Quit

 try_update:

FunctionEnd


; detect adaba version
Function DetectAdaba
  ClearErrors
  ReadRegStr $2 HKLM  "${PRODUCT_REGISTRY_PREF}" "ApplicationPath"
  IfErrors DetectAdaba_done
   ; create a custom page to either run adaba or deinstall it!
   Call ReinstallAdaba
  
 DetectAdaba_done:
FunctionEnd

Function .onInit
  ; preven multiple instances running at the same time
  System::Call 'kernel32::CreateMutexA(i 0, i 0, t "adabaInstallerMutex") i .r1 ?e'
  Pop $R0
 
  StrCmp $R0 0 +3
   MessageBox MB_OK|MB_ICONEXCLAMATION "The installer is already running."
   Abort

  ; is adaba already installed?
  Call DetectAdaba

  InitPluginsDir
  File /oname=$PLUGINSDIR\QueryDatadir.ini QueryDatadir.ini
  
  !insertmacro MUI_LANGDLL_DISPLAY
FunctionEnd

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) wurde erfolgreich deinstalliert."
FunctionEnd

Function un.onInit
!insertmacro MUI_UNGETLANGUAGE
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Mchten Sie $(^Name) und seine Komponenten deinstallieren?" IDYES +2
  Abort

  StrCpy $UNINST_DELDATA ""
  IfFileExists $INSTDIR\data\adaba.id 0 done_deldata
  MessageBox MB_YESNO "Wollen Sie die Audio-Daten von Ihrer Festplatte lschen?" /SD IDYES IDYES done_deldata
  StrCpy $UNINST_DELDATA "no"

  done_deldata:
FunctionEnd


!include "adaba_sections.nsi"



; JMZ a custom page for data
Function InstallDatadir_set
;; darn, the debian-package of nsis has no logging compiled in...
;   LogSet on

  Call GetParameters
  Pop $2

  StrCpy $OPTIONS $2

  ${GetOptions} $OPTIONS "/SOURCEDIR=" $DATASOURCEDIR
  IfErrors datasource_unset datasource_done
  datasource_unset:
   StrCpy $DATASOURCEDIR "$EXEDIR"
  datasource_done:
   ClearErrors

;  MessageBox MB_OK 'datadir $DATASOURCEDIR'

  IfFileExists $DATASOURCEDIR/dataz/*.* datasource_abort datasource_ask
  datasource_abort:
;  MessageBox MB_OK 'found datadir $DATASOURCEDIR'
  abort

  datasource_ask:

; check whether some data gets installed and make sure we do set the adaba.id and the registry correctly!
 !insertmacro SectionFlagIsSet ${SEC03} ${SF_PSELECTED} isSel chkAll
chkAll: 
 !insertmacro SectionFlagIsSet ${SEC03} ${SF_SELECTED} isSel datasource_abort
isSel:

 !insertmacro MUI_HEADER_TEXT "Quellverzeichnis auswhlen" "Whlen Sie das Verzeichnis aus, aus dem adaba die Audiodaten installieren soll."
; !insertmacro MUI_INSTALLOPTIONS_DISPLAY "xxx"

  Push $R0
  InstallOptions::dialog $PLUGINSDIR\QueryDatadir.ini
  Pop $R0
  datasource_finish:
FunctionEnd

Function InstallDatadir_validate
  ReadINIStr $DATASOURCEDIR "$PLUGINSDIR\QueryDatadir.ini" "Field 3" "State"
FunctionEnd

