// Transcriber.java
// $Id: Transcriber.java 1636 2007-05-26 10:45:14Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

// last modified: 
// 01/10/2002:: no closing of frames
//
// branch test

import at.iem.adaba.*;
import at.iem.adaba.transcriber.*;

import at.iem.tools.gui.CustomFileFilter;
import javax.swing.*;
import java.io.File;

public class Transcriber extends JPanel {
    JFrame frame;
    at.iem.adaba.database.TranscriptionDataBase dataBase;

    public Transcriber(File fil) throws Exception {
	AdabaConstants.setLook(0);
	if (fil==null){
	    JFileChooser fc = new JFileChooser(".");
	    fc.addChoosableFileFilter(new CustomFileFilter("adaba-Transkriptions-Datenbanken", ".atd"));
	    if (fc.showDialog(this, "adaba")==JFileChooser.APPROVE_OPTION){
		fil=fc.getSelectedFile();
		if (!fil.exists()){
		    if (!fil.getName().toLowerCase().endsWith(".atd"))
			fil = new File(fil.getParent(), fil.getName()+".atd");
		}
	    } else System.exit(0);
	}

	if(AdabaShared.getPWD()==null)AdabaShared.setPWD(fil);
	dataBase = at.iem.adaba.database.Factory.open(fil.getAbsolutePath(), "", "", false);
	if (dataBase==null){
	    JOptionPane.showMessageDialog(this,
					  "Konnte Datenbank nicht ffnen !");
	    System.exit(0);
	}

	frame = new JFrame(AdabaShared.Labels.getString("TranscriberTitle")+
			   " "+AdabaVersion.getTranscriberVersion()+
			   "   -   "+fil.toString());
	TransGUI gui = new TransGUI(frame, dataBase);

	frame.getContentPane().add("Center", gui);
	
	frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
	frame.pack();
	frame.setVisible(true);
    }
    public static void main(String s[]) throws Exception {
	File fil = null;

	if (s.length!=0 && s[0].length()!=0){
	    fil = new File(s[0]);
	    if (!fil.isFile())fil=null;
	}
	new Transcriber(fil);
    }
    static final long serialVersionUID = 1L;
}
