// AdabaConstants.java
// $Id: AdabaConstants.java 1757 2007-06-21 11:33:57Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

package at.iem.adaba;

import java.awt.Color;
import java.io.File;

import javax.swing.UIManager;

/**
 * Konstante Werte, wie Farbe,....
 */

public class AdabaConstants {
    // COLOUR-constants
    public static final boolean COLOUR = false;
    public static final Color SearchBackground=(COLOUR)?(new Color(0, 0, 0, 0)):null;

    public static final Color TranscriptionBackground=(new Color(184,207,229));
    public static final Color AdabaSelectionBackground=(new Color( 86,147,207) );
    public static final Color AdabaSelectionForeground=Color.WHITE;
    public static final Color AdabaGreyBackground=(new Color(229,229,229) );

    public static boolean setLook(int i){
	try {
	   switch (i) {
	   case 1: // WINDOF
	       UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
	       break;
	   case 2: // MAC
	       UIManager.setLookAndFeel("javax.swing.plaf.mac.MacLookAndFeel");
	       break;
	   case 3: // MOTIF
	       UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
	       break;
	   default:
	       UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
               UIManager.put("TabbedPane.selected", AdabaSelectionBackground );
               UIManager.put("TabbedPane.selectionBackground", AdabaSelectionBackground );
               UIManager.put("TabbedPane.selectionForeground", AdabaSelectionForeground );

               UIManager.put("List.selectionBackground", AdabaSelectionBackground );
               UIManager.put("List.selectionForeground", AdabaSelectionForeground );

               UIManager.put("ComboBox.selectionBackground", AdabaSelectionBackground );
               UIManager.put("ComboBox.selectionForeground", AdabaSelectionForeground );

               UIManager.put("Panel.background", AdabaGreyBackground);
               //UIManager.put("Button.background", AdabaGreyBackground);
               UIManager.put("RadioButton.background", AdabaGreyBackground);
               UIManager.put("CheckBox.background", AdabaGreyBackground);
               UIManager.put("ComboBox.background", AdabaGreyBackground);
               UIManager.put("EditoPane.background", AdabaGreyBackground);
               //UIManager.put("Button.background", AdabaGreyBackground);
	       break;
	   case -1:
	   }
	}  catch (Exception ex) {
	    return false;
	}
        
        /*
               AuditoryCues.allAuditoryCues
               AuditoryCues.cueList
               AuditoryCues.defaultCueList
               AuditoryCues.noAuditoryCues
               Button.background
               Button.border
               Button.darkShadow
               Button.defaultButtonFollowsFocus
               Button.disabledText
               Button.disabledToolBarBorderBackground
               Button.focus
               Button.focusInputMap
               Button.font
               Button.foreground
               Button.gradient
               Button.highlight
               Button.light
               Button.margin
               Button.rollover
               Button.rolloverIconType
               Button.select
               Button.shadow
               Button.textIconGap
               Button.textShiftOffset
               Button.toolBarBorderBackground
               ButtonUI
               CheckBox.background
               CheckBox.border
               CheckBox.disabledText
               CheckBox.focus
               CheckBox.focusInputMap
               CheckBox.font
               CheckBox.foreground
               CheckBox.gradient
               CheckBox.icon
               CheckBox.margin
               CheckBox.rollover
               CheckBox.textIconGap
               CheckBox.textShiftOffset
               CheckBoxMenuItem.acceleratorFont
               CheckBoxMenuItem.acceleratorForeground
               CheckBoxMenuItem.acceleratorSelectionForeground
               CheckBoxMenuItem.arrowIcon
               CheckBoxMenuItem.background
               CheckBoxMenuItem.border
               CheckBoxMenuItem.borderPainted
               CheckBoxMenuItem.checkIcon
               CheckBoxMenuItem.commandSound
               CheckBoxMenuItem.disabledForeground
               CheckBoxMenuItem.font
               CheckBoxMenuItem.foreground
               CheckBoxMenuItem.gradient
               CheckBoxMenuItem.margin
               CheckBoxMenuItem.selectionBackground
               CheckBoxMenuItem.selectionForeground
               CheckBoxMenuItemUI
               CheckBoxUI
               Checkbox.select
               ColorChooser.background
               ColorChooser.font
               ColorChooser.foreground
               ColorChooser.swatchesDefaultRecentColor
               ColorChooser.swatchesRecentSwatchSize
               ColorChooser.swatchesSwatchSize
               ColorChooserUI
               ComboBox.ancestorInputMap
               ComboBox.background
               ComboBox.buttonBackground
               ComboBox.buttonDarkShadow
               ComboBox.buttonHighlight
               ComboBox.buttonShadow
               ComboBox.disabledBackground
               ComboBox.disabledForeground
               ComboBox.font
               ComboBox.foreground
               ComboBox.selectionBackground
               ComboBox.selectionForeground
               ComboBox.timeFactor
               ComboBoxUI
               Desktop.ancestorInputMap
               Desktop.background
               DesktopIcon.background
               DesktopIcon.border
               DesktopIcon.font
               DesktopIcon.foreground
               DesktopIcon.width
               DesktopIconUI
               DesktopPaneUI
               EditorPane.background
               EditorPane.border
               EditorPane.caretBlinkRate
               EditorPane.caretForeground
               EditorPane.focusInputMap
               EditorPane.font
               EditorPane.foreground
               EditorPane.inactiveForeground
               EditorPane.margin
               EditorPane.selectionBackground
               EditorPane.selectionForeground
               EditorPaneUI
               FileChooser.ancestorInputMap
               FileChooser.detailsViewIcon
               FileChooser.fileNameLabelMnemonic
               FileChooser.filesOfTypeLabelMnemonic
               FileChooser.homeFolderIcon
               FileChooser.listViewIcon
               FileChooser.lookInLabelMnemonic
               FileChooser.newFolderIcon
               FileChooser.readOnly
               FileChooser.upFolderIcon
               FileChooser.useSystemExtensionHiding
               FileChooser.usesSingleFilePane
               FileChooserUI
               FileView.computerIcon
               FileView.directoryIcon
               FileView.fileIcon
               FileView.floppyDriveIcon
               FileView.hardDriveIcon
               FormattedTextField.background
               FormattedTextField.border
               FormattedTextField.caretBlinkRate
               FormattedTextField.caretForeground
               FormattedTextField.focusInputMap
               FormattedTextField.font
               FormattedTextField.foreground
               FormattedTextField.inactiveBackground
               FormattedTextField.inactiveForeground
               FormattedTextField.margin
               FormattedTextField.selectionBackground
               FormattedTextField.selectionForeground
               FormattedTextFieldUI
               InternalFrame.activeTitleBackground
               InternalFrame.activeTitleForeground
               InternalFrame.activeTitleGradient
               InternalFrame.border
               InternalFrame.borderColor
               InternalFrame.borderDarkShadow
               InternalFrame.borderHighlight
               InternalFrame.borderLight
               InternalFrame.borderShadow
               InternalFrame.closeIcon
               InternalFrame.closeSound
               InternalFrame.icon
               InternalFrame.iconifyIcon
               InternalFrame.inactiveTitleBackground
               InternalFrame.inactiveTitleForeground
               InternalFrame.maximizeIcon
               InternalFrame.maximizeSound
               InternalFrame.minimizeIcon
               InternalFrame.minimizeSound
               InternalFrame.optionDialogBorder
               InternalFrame.paletteBorder
               InternalFrame.paletteCloseIcon
               InternalFrame.paletteTitleHeight
               InternalFrame.restoreDownSound
               InternalFrame.restoreUpSound
               InternalFrame.titleFont
               InternalFrameUI
               Label.background
               Label.disabledForeground
               Label.disabledShadow
               Label.font
               Label.foreground
               LabelUI
               List.background
               List.cellRenderer
               List.focusCellHighlightBorder
               List.focusInputMap
               List.focusInputMap.RightToLeft
               List.font
               List.foreground
               List.selectionBackground
               List.selectionForeground
               List.timeFactor
               ListUI
               Menu.acceleratorFont
               Menu.acceleratorForeground
               Menu.acceleratorSelectionForeground
               Menu.arrowIcon
               Menu.background
               Menu.border
               Menu.borderPainted
               Menu.checkIcon
               Menu.crossMenuMnemonic
               Menu.disabledForeground
               Menu.font
               Menu.foreground
               Menu.margin
               Menu.menuPopupOffsetX
               Menu.menuPopupOffsetY
               Menu.opaque
               Menu.selectionBackground
               Menu.selectionForeground
               Menu.shortcutKeys
               Menu.submenuPopupOffsetX
               Menu.submenuPopupOffsetY
               MenuBar.background
               MenuBar.border
               MenuBar.borderColor
               MenuBar.font
               MenuBar.foreground
               MenuBar.gradient
               MenuBar.highlight
               MenuBar.shadow
               MenuBar.windowBindings
               MenuBarUI
               MenuItem.acceleratorDelimiter
               MenuItem.acceleratorFont
               MenuItem.acceleratorForeground
               MenuItem.acceleratorSelectionForeground
               MenuItem.arrowIcon
               MenuItem.background
               MenuItem.border
               MenuItem.borderPainted
               MenuItem.checkIcon
               MenuItem.commandSound
               MenuItem.disabledForeground
               MenuItem.font
               MenuItem.foreground
               MenuItem.margin
               MenuItem.selectionBackground
               MenuItem.selectionForeground
               MenuItemUI
               MenuUI
               OptionPane.background
               OptionPane.border
               OptionPane.buttonAreaBorder
               OptionPane.buttonClickThreshhold
               OptionPane.errorDialog.border.background
               OptionPane.errorDialog.titlePane.background
               OptionPane.errorDialog.titlePane.foreground
               OptionPane.errorDialog.titlePane.shadow
               OptionPane.errorIcon
               OptionPane.errorSound
               OptionPane.font
               OptionPane.foreground
               OptionPane.informationIcon
               OptionPane.informationSound
               OptionPane.messageAreaBorder
               OptionPane.messageForeground
               OptionPane.minimumSize
               OptionPane.questionDialog.border.background
               OptionPane.questionDialog.titlePane.background
               OptionPane.questionDialog.titlePane.foreground
               OptionPane.questionDialog.titlePane.shadow
               OptionPane.questionIcon
               OptionPane.questionSound
               OptionPane.warningDialog.border.background
               OptionPane.warningDialog.titlePane.background
               OptionPane.warningDialog.titlePane.foreground
               OptionPane.warningDialog.titlePane.shadow
               OptionPane.warningIcon
               OptionPane.warningSound
               OptionPane.windowBindings
               OptionPaneUI
               Panel.background
               Panel.font
               Panel.foreground
               PanelUI
               PasswordField.background
               PasswordField.border
               PasswordField.caretBlinkRate
               PasswordField.caretForeground
               PasswordField.focusInputMap
               PasswordField.font
               PasswordField.foreground
               PasswordField.inactiveBackground
               PasswordField.inactiveForeground
               PasswordField.margin
               PasswordField.selectionBackground
               PasswordField.selectionForeground
               PasswordFieldUI
               PopupMenu.background
               PopupMenu.border
               PopupMenu.consumeEventOnClose
               PopupMenu.font
               PopupMenu.foreground
               PopupMenu.popupSound
               PopupMenu.selectedWindowInputMapBindings
               PopupMenu.selectedWindowInputMapBindings.RightToLeft
               PopupMenuSeparatorUI
               PopupMenuUI
               ProgressBar.background
               ProgressBar.border
               ProgressBar.cellLength
               ProgressBar.cellSpacing
               ProgressBar.cycleTime
               ProgressBar.font
               ProgressBar.foreground
               ProgressBar.horizontalSize
               ProgressBar.repaintInterval
               ProgressBar.selectionBackground
               ProgressBar.selectionForeground
               ProgressBar.verticalSize
               ProgressBarUI
               RadioButton.background
               RadioButton.border
               RadioButton.darkShadow
               RadioButton.disabledText
               RadioButton.focus
               RadioButton.focusInputMap
               RadioButton.font
               RadioButton.foreground
               RadioButton.gradient
               RadioButton.highlight
               RadioButton.icon
               RadioButton.light
               RadioButton.margin
               RadioButton.rollover
               RadioButton.select
               RadioButton.shadow
               RadioButton.textIconGap
               RadioButton.textShiftOffset
               RadioButtonMenuItem.acceleratorFont
               RadioButtonMenuItem.acceleratorForeground
               RadioButtonMenuItem.acceleratorSelectionForeground
               RadioButtonMenuItem.arrowIcon
               RadioButtonMenuItem.background
               RadioButtonMenuItem.border
               RadioButtonMenuItem.borderPainted
               RadioButtonMenuItem.checkIcon
               RadioButtonMenuItem.commandSound
               RadioButtonMenuItem.disabledForeground
               RadioButtonMenuItem.font
               RadioButtonMenuItem.foreground
               RadioButtonMenuItem.gradient
               RadioButtonMenuItem.margin
               RadioButtonMenuItem.selectionBackground
               RadioButtonMenuItem.selectionForeground
               RadioButtonMenuItemUI
               RadioButtonUI
               RootPane.ancestorInputMap
               RootPane.colorChooserDialogBorder
               RootPane.defaultButtonWindowKeyBindings
               RootPane.errorDialogBorder
               RootPane.fileChooserDialogBorder
               RootPane.frameBorder
               RootPane.informationDialogBorder
               RootPane.plainDialogBorder
               RootPane.questionDialogBorder
               RootPane.warningDialogBorder
               RootPaneUI
               ScrollBar.allowsAbsolutePositioning
               ScrollBar.ancestorInputMap
               ScrollBar.ancestorInputMap.RightToLeft
               ScrollBar.background
               ScrollBar.darkShadow
               ScrollBar.foreground
               ScrollBar.gradient
               ScrollBar.highlight
               ScrollBar.maximumThumbSize
               ScrollBar.minimumThumbSize
               ScrollBar.shadow
               ScrollBar.thumb
               ScrollBar.thumbDarkShadow
               ScrollBar.thumbHighlight
               ScrollBar.thumbShadow
               ScrollBar.track
               ScrollBar.trackHighlight
               ScrollBar.width
               ScrollBarUI
               ScrollPane.ancestorInputMap
               ScrollPane.ancestorInputMap.RightToLeft
               ScrollPane.background
               ScrollPane.border
               ScrollPane.font
               ScrollPane.foreground
               ScrollPaneUI
               Separator.background
               Separator.foreground
               Separator.highlight
               Separator.shadow
               SeparatorUI
               Slider.altTrackColor
               Slider.background
               Slider.focus
               Slider.focusGradient
               Slider.focusInputMap
               Slider.focusInputMap.RightToLeft
               Slider.focusInsets
               Slider.foreground
               Slider.gradient
               Slider.highlight
               Slider.horizontalSize
               Slider.horizontalThumbIcon
               Slider.majorTickLength
               Slider.minimumHorizontalSize
               Slider.minimumVerticalSize
               Slider.shadow
               Slider.tickColor
               Slider.trackWidth
               Slider.verticalSize
               Slider.verticalThumbIcon
               SliderUI
               Spinner.ancestorInputMap
               Spinner.arrowButtonBorder
               Spinner.arrowButtonInsets
               Spinner.arrowButtonSize
               Spinner.background
               Spinner.border
               Spinner.editorBorderPainted
               Spinner.font
               Spinner.foreground
               SpinnerUI
               SplitPane.ancestorInputMap
               SplitPane.background
               SplitPane.border
               SplitPane.centerOneTouchButtons
               SplitPane.darkShadow
               SplitPane.dividerFocusColor
               SplitPane.dividerSize
               SplitPane.highlight
               SplitPane.oneTouchButtonsOpaque
               SplitPane.shadow
               SplitPaneDivider.border
               SplitPaneDivider.draggingColor
               SplitPaneUI
               TabbedPane.ancestorInputMap
               TabbedPane.background
               TabbedPane.borderHightlightColor
               TabbedPane.contentAreaColor
               TabbedPane.contentBorderInsets
               TabbedPane.contentOpaque
               TabbedPane.darkShadow
               TabbedPane.focus
               TabbedPane.focusInputMap
               TabbedPane.font
               TabbedPane.foreground
               TabbedPane.highlight
               TabbedPane.light
               TabbedPane.selectHighlight
               TabbedPane.selected
               TabbedPane.selectedTabPadInsets
               TabbedPane.shadow
               TabbedPane.tabAreaBackground
               TabbedPane.tabAreaInsets
               TabbedPane.tabInsets
               TabbedPane.tabRunOverlay
               TabbedPane.tabsOpaque
               TabbedPane.tabsOverlapBorder
               TabbedPane.textIconGap
               TabbedPane.unselectedBackground
               TabbedPaneUI
               Table.ancestorInputMap
               Table.ancestorInputMap.RightToLeft
               Table.background
               Table.focusCellBackground
               Table.focusCellForeground
               Table.focusCellHighlightBorder
               Table.font
               Table.foreground
               Table.gridColor
               Table.scrollPaneBorder
               Table.selectionBackground
               Table.selectionForeground
               TableHeader.background
               TableHeader.cellBorder
               TableHeader.font
               TableHeader.foreground
               TableHeaderUI
               TableUI
               TextArea.background
               TextArea.border
               TextArea.caretBlinkRate
               TextArea.caretForeground
               TextArea.focusInputMap
               TextArea.font
               TextArea.foreground
               TextArea.inactiveForeground
               TextArea.margin
               TextArea.selectionBackground
               TextArea.selectionForeground
               TextAreaUI
               TextField.background
               TextField.border
               TextField.caretBlinkRate
               TextField.caretForeground
               TextField.darkShadow
               TextField.focusInputMap
               TextField.font
               TextField.foreground
               TextField.highlight
               TextField.inactiveBackground
               TextField.inactiveForeground
               TextField.light
               TextField.margin
               TextField.selectionBackground
               TextField.selectionForeground
               TextField.shadow
               TextFieldUI
               TextPane.background
               TextPane.border
               TextPane.caretBlinkRate
               TextPane.caretForeground
               TextPane.focusInputMap
               TextPane.font
               TextPane.foreground
               TextPane.inactiveForeground
               TextPane.margin
               TextPane.selectionBackground
               TextPane.selectionForeground
               TextPaneUI
               TitledBorder.border
               TitledBorder.font
               TitledBorder.titleColor
               ToggleButton.background
               ToggleButton.border
               ToggleButton.darkShadow
               ToggleButton.disabledText
               ToggleButton.focus
               ToggleButton.focusInputMap
               ToggleButton.font
               ToggleButton.foreground
               ToggleButton.gradient
               ToggleButton.highlight
               ToggleButton.light
               ToggleButton.margin
               ToggleButton.select
               ToggleButton.shadow
               ToggleButton.textIconGap
               ToggleButton.textShiftOffset
               ToggleButtonUI
               ToolBar.ancestorInputMap
               ToolBar.background
               ToolBar.border
               ToolBar.borderColor
               ToolBar.darkShadow
               ToolBar.dockingBackground
               ToolBar.dockingForeground
               ToolBar.floatingBackground
               ToolBar.floatingForeground
               ToolBar.font
               ToolBar.foreground
               ToolBar.highlight
               ToolBar.isRollover
               ToolBar.light
               ToolBar.nonrolloverBorder
               ToolBar.rolloverBorder
               ToolBar.separatorSize
               ToolBar.shadow
               ToolBarSeparatorUI
               ToolBarUI
               ToolTip.background
               ToolTip.backgroundInactive
               ToolTip.border
               ToolTip.borderInactive
               ToolTip.font
               ToolTip.foreground
               ToolTip.foregroundInactive
               ToolTip.hideAccelerator
               ToolTipUI
               Tree.ancestorInputMap
               Tree.background
               Tree.changeSelectionWithFocus
               Tree.closedIcon
               Tree.collapsedIcon
               Tree.drawsFocusBorderAroundIcon
               Tree.editorBorder
               Tree.expandedIcon
               Tree.focusInputMap
               Tree.focusInputMap.RightToLeft
               Tree.font
               Tree.foreground
               Tree.hash
               Tree.leafIcon
               Tree.leftChildIndent
               Tree.line
               Tree.lineTypeDashed
               Tree.openIcon
               Tree.paintLines
               Tree.rightChildIndent
               Tree.rowHeight
               Tree.scrollsOnExpand
               Tree.selectionBackground
               Tree.selectionBorderColor
               Tree.selectionForeground
               Tree.textBackground
               Tree.textForeground
               Tree.timeFactor
               TreeUI
               Viewport.background
               Viewport.font
               Viewport.foreground
               ViewportUI
               activeCaption
               activeCaptionBorder
               activeCaptionText
               control
               controlDkShadow
               controlHighlight
               controlLtHighlight
               controlShadow
               controlText
               desktop
               inactiveCaption
               inactiveCaptionBorder
               inactiveCaptionText
               info
               infoText
               menu
               menuText
               scrollbar
               text
               textHighlight
               textHighlightText
               textInactiveText
               textText
               window
               windowBorder
               windowText
             */

	return true;
    }

    public static boolean getUseBasicPlayer(){
        if(1==1){ // kind of an "ifdef"
            return true;
        } else {
            return false;
        }
    }

    public static String getPreferenceRoot() {
        return new String("/adaba");
    }

    // the rest
    private AdabaConstants(){
	/* this should never happen */
    }
}
