// AdabaMessages.java
// $Id: AdabaMessages.java 512 2004-03-08 19:10:57Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

package at.iem.adaba;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Ausgabefunktionen fr nichtgrafische Objekte...
 */

public class AdabaMessages {
    private static JPanel parent;
    public static void setParent(JPanel p){
	parent = p;
    }

    public static void showMessage(String mess){
	JOptionPane.showMessageDialog(parent, mess);
    }

    public static void showMessageDetails(String mess, String details){
	if (details==null)showMessage(mess);
	else {	
	    Object[] options = {"OK",
				"Details"};
	    int n = JOptionPane.showOptionDialog(parent,
					     mess,
					     "Information",
					     JOptionPane.YES_NO_OPTION,
					     JOptionPane.QUESTION_MESSAGE,
					     null,     //don't use a custom Icon
					     options,  //the titles of buttons
					     options[0]); //default button title

	    if (n==1){
		JTextArea textArea = new JTextArea(details);
		textArea.setWrapStyleWord(true);
		textArea.setEditable(false);
		JScrollPane areaScrollPane = new JScrollPane(textArea);
		areaScrollPane.setVerticalScrollBarPolicy(
							  JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		areaScrollPane.setPreferredSize(new Dimension(250, 250));
		JOptionPane.showMessageDialog(parent, areaScrollPane);
	    }
	}
    }
    public static boolean showYesNoMessage(String titl, String mess){
	return (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(
		   parent,
		   mess,  titl,
		   JOptionPane.YES_NO_OPTION, JOptionPane.ERROR_MESSAGE));
    }
}
