// AdabaSAMPAhelp.java
// $Id: AdabaSAMPAhelp.java 1804 2007-06-26 19:58:00Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

// 03/10/2002

package at.iem.adaba;

import at.iem.tools.linguistic.IPA;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;

/**
 * help JFrame :: SAMPA2IPA-Tabelle
 */

public class AdabaSAMPAhelp {
        String[][]consonants={
            {"p", " "+IPA.sampa2ipa("p"), "101"},
            {"b", " "+IPA.sampa2ipa("b"), "102"},
            {"t", " "+IPA.sampa2ipa("t"), "103"},
            {"d", " "+IPA.sampa2ipa("d"), "104"},
            {"t'", " "+IPA.sampa2ipa("t'"), "105"},
            {"d'", " "+IPA.sampa2ipa("d'"), "106"},
            {"c", " "+IPA.sampa2ipa("c"), "107"},
            {"J\\", " "+IPA.sampa2ipa("J\\"), "108"},
            {"k", " "+IPA.sampa2ipa("k"), "109"},
            {"g", " "+IPA.sampa2ipa("g"), "110"},
            {"q", " "+IPA.sampa2ipa("q"), "111"},
            {"G\\", " "+IPA.sampa2ipa("G\\"), "112"},
            {"?", " "+IPA.sampa2ipa("?"), "113"},

            {"m", " "+IPA.sampa2ipa("m"), "114"},
            {"F", " "+IPA.sampa2ipa("F"), "115"},
            {"n", " "+IPA.sampa2ipa("n"), "116"},
            {"n'", " "+IPA.sampa2ipa("n'"), "117"},
            {"J", " "+IPA.sampa2ipa("J"), "118"},
            {"N", " "+IPA.sampa2ipa("N"), "119"},
            {"N\\", " "+IPA.sampa2ipa("N\\"), "120"},

            {"B\\", " "+IPA.sampa2ipa("B\\"), "121"},
            {"r", " "+IPA.sampa2ipa("r"), "122"},
            {"R", " "+IPA.sampa2ipa("R"), "123"},

            {"4", " "+IPA.sampa2ipa("4"), "124"},
            {"r'", " "+IPA.sampa2ipa("r'"), "125"},

            {"p\\", " "+IPA.sampa2ipa("p\\"), "126"},
            {"B", " "+IPA.sampa2ipa("B"), "127"},
            {"f", " "+IPA.sampa2ipa("f"), "128"},
            {"v", " "+IPA.sampa2ipa("v"), "129"},
            {"T", " "+IPA.sampa2ipa("T"), "130"},
            {"D", " "+IPA.sampa2ipa("D"), "131"},
            {"s", " "+IPA.sampa2ipa("s"), "132"},
            {"z", " "+IPA.sampa2ipa("z"), "133"},
            {"S", " "+IPA.sampa2ipa("S"), "134"},
            {"Z", " "+IPA.sampa2ipa("Z"), "135"},
            {"s'", " "+IPA.sampa2ipa("s'"), "136"},
            {"z'", " "+IPA.sampa2ipa("z'"), "137"},
            {"C", " "+IPA.sampa2ipa("C"), "138"},
            {"j\\", " "+IPA.sampa2ipa("j\\"), "139"},
            {"x", " "+IPA.sampa2ipa("x"), "140"},
            {"G", " "+IPA.sampa2ipa("G"), "141"},
            {"X", " "+IPA.sampa2ipa("X"), "142"},
            {"R\\", " "+IPA.sampa2ipa("R\\"), "143"},
            {"X\\", " "+IPA.sampa2ipa("X\\"), "144"},
            {"?\\", " "+IPA.sampa2ipa("?\\"), "145"},
            {"h", " "+IPA.sampa2ipa("h"), "146"},
            {"h\\", " "+IPA.sampa2ipa("h\\"), "147"},

            {"K", " "+IPA.sampa2ipa("K"), "148"},
            {"K\\", " "+IPA.sampa2ipa("K\\"), "149"},

            {"P", " "+IPA.sampa2ipa("P"), "150"},
            {"v\\", " "+IPA.sampa2ipa("v\\"), "150"},
            {"r\\", " "+IPA.sampa2ipa("r\\"), "151"},
            {"r\\'", " "+IPA.sampa2ipa("r\\'"), "152"},
            {"j", " "+IPA.sampa2ipa("j"), "153"},
            {"M\\", " "+IPA.sampa2ipa("M\\"), "154"},

            {"l", " "+IPA.sampa2ipa("l"), "155"},
            {"l'", " "+IPA.sampa2ipa("l'"), "156"},
            {"L", " "+IPA.sampa2ipa("L"), "157"},
            {"L\\", " "+IPA.sampa2ipa("L\\"), "158"},

            {"b_<", " "+IPA.sampa2ipa("b_<"), "160"},
            {"d_<", " "+IPA.sampa2ipa("d_<"), "162"},
            {"J\\_<", " "+IPA.sampa2ipa("J\\_<") , "164"},
            {"g_<", " "+IPA.sampa2ipa("g_<"), "166"},
            {"G\\_<", " "+IPA.sampa2ipa("G\\_<") , "168"},

            {"W", " "+IPA.sampa2ipa("W"), "169"},
            {"w", " "+IPA.sampa2ipa("w"), "170"},
            {"H", " "+IPA.sampa2ipa("H"), "171"},
            {"H\\", " "+IPA.sampa2ipa("H\\"), "172"},
            {">\\", " "+IPA.sampa2ipa(">\\"), "173"},
            {"<\\", " "+IPA.sampa2ipa("<\\"), "174"},
            {"x\\", " "+IPA.sampa2ipa("x\\"), "175"},

            {"O\\", " "+IPA.sampa2ipa("O\\"), "176"},
            {"|\\", " "+IPA.sampa2ipa("|\\"), "177"},
            {"!\\", " "+IPA.sampa2ipa("!\\"), "178"},
            {"=\\", " "+IPA.sampa2ipa("=\\"), "179"},
            {"|\\|\\", " "+IPA.sampa2ipa("|\\|\\") , "180"},
            {"l\\", " "+IPA.sampa2ipa("l\\"), "181"},
            {"s\\", " "+IPA.sampa2ipa("s\\"), "182"},
            {"z\\", " "+IPA.sampa2ipa("z\\"), "183"},

            {"_>", " "+IPA.sampa2ipa("_>"), "401"},
            {"_(", " "+IPA.sampa2ipa("_("), "433"},

            {"'", " "+IPA.sampa2ipa("'"), ""},
            {"t\\", " "+IPA.sampa2ipa("t\\"), ""},
            {"S\\", " "+IPA.sampa2ipa("S\\"), ""},
            {"k\\", " "+IPA.sampa2ipa("k\\"), ""},
            {"5", " "+IPA.sampa2ipa("5"), ""},
            {"C\\", " "+IPA.sampa2ipa("C\\"), ""}
        };
	
        String[][]vowels={
            {"i", " "+IPA.sampa2ipa("i"), "301"}, 
            {"e", " "+IPA.sampa2ipa("e"), "302"}, 
            {"E", " "+IPA.sampa2ipa("E"), "303"}, 
            {"a", " "+IPA.sampa2ipa("a"), "304"}, 
            {"A", " "+IPA.sampa2ipa("A"), "305"}, 
            {"O", " "+IPA.sampa2ipa("O"), "306"}, 
            {"o", " "+IPA.sampa2ipa("o"), "307"}, 
            {"u", " "+IPA.sampa2ipa("u"), "308"}, 
            {"y", " "+IPA.sampa2ipa("y"), "309"}, 
            {"2", " "+IPA.sampa2ipa("2"), "310"}, 
            {"9", " "+IPA.sampa2ipa("9"), "311"}, 
            {"&", " "+IPA.sampa2ipa("&"), "312"}, 
            {"Q", " "+IPA.sampa2ipa("Q"), "313"}, 
            {"V", " "+IPA.sampa2ipa("V"), "314"}, 
            {"7", " "+IPA.sampa2ipa("7"), "315"}, 
            {"M", " "+IPA.sampa2ipa("M"), "316"}, 
            {"1", " "+IPA.sampa2ipa("1"), "317"}, 
            {"}", " "+IPA.sampa2ipa("}"), "318"}, 
            {"I", " "+IPA.sampa2ipa("I"), "319"}, 
            {"Y", " "+IPA.sampa2ipa("Y"), "310"}, 
            {"U", " "+IPA.sampa2ipa("U"), "321"}, 
            {"@", " "+IPA.sampa2ipa("@"), "322"}, 
            {"8", " "+IPA.sampa2ipa("8"), "323"}, 
            {"6", " "+IPA.sampa2ipa("6"), "324"}, 
            {"{", " "+IPA.sampa2ipa("{"), "325"}, 
            {"3", " "+IPA.sampa2ipa("3"), "326"}, 

            {"3\\", " "+IPA.sampa2ipa("3\\"), "395"}, 
            {"@\\", " "+IPA.sampa2ipa("@\\"), "397"}, 

            {"\"", " "+IPA.sampa2ipa("\""), "501"}, 
            {"%", " "+IPA.sampa2ipa("%"), "502"}, 
            {":", " "+IPA.sampa2ipa(":"), "503"}, 
            {":\\", " "+IPA.sampa2ipa(":\\"), "504"}, 
            {"_X", " "+IPA.sampa2ipa("_X"), "505"}, 
            {".", " "+IPA.sampa2ipa("."), "506"}, 
            {"|", " "+IPA.sampa2ipa("|"), "507"}, 
            {"||", " "+IPA.sampa2ipa("||"), "508"}, 
            {"-\\", " "+IPA.sampa2ipa("-\\"), "509"}, 

            {"<R>", " "+IPA.sampa2ipa("<R>"), "510"}, 
            {"</>", " "+IPA.sampa2ipa("</>"), "510"}, 
            {"<F>", " "+IPA.sampa2ipa("<F>"), "511"}, 
            {"<\\>", " "+IPA.sampa2ipa("<\\>"), "511"}, 

            {"_T", " "+IPA.sampa2ipa("_T"), "512"}, 
            {"_H", " "+IPA.sampa2ipa("_H"), "513"}, 
            {"_M", " "+IPA.sampa2ipa("_M"), "514"}, 
            {"_L", " "+IPA.sampa2ipa("_L"), "515"}, 
            {"_B", " "+IPA.sampa2ipa("_B"), "516"}, 
            {"!", " "+IPA.sampa2ipa("!"), "517"}, 
            {"<!>", " "+IPA.sampa2ipa("<!>"), "517"}, 
            {"^", " "+IPA.sampa2ipa("^"), "518"}, 
            {"<^>", " "+IPA.sampa2ipa("<^>"), "518"}, 
            {"<T>", " "+IPA.sampa2ipa("<T>"), "519"}, 
            {"<H>", " "+IPA.sampa2ipa("<H>"), "520"}, 
            {"<M>", " "+IPA.sampa2ipa("<M>"), "521"}, 
            {"<L>", " "+IPA.sampa2ipa("<L>"), "522"}, 
            {"<B>", " "+IPA.sampa2ipa("<B>"), "523"}, 
            {"_L_H", " "+IPA.sampa2ipa("_L_H"), "524"}, 
            {"_/", " "+IPA.sampa2ipa("_/"), "524"}, 
            {"_R", " "+IPA.sampa2ipa("_R"), "524"}, 
            {"_H_L", " "+IPA.sampa2ipa("_H_L"), "525"}, 
            {"_\\", " "+IPA.sampa2ipa("_\\"), "525"}, 
            {"_F", " "+IPA.sampa2ipa("_F"), "525"}, 
            /*
              {"_H_T", " "+IPA.sampa2ipa("_H_T"), "526"},
              {"_B_T", " "+IPA.sampa2ipa("_B_T"), "527"},
            */
            {"_R_F", " "+IPA.sampa2ipa("_R_F"), "528"}, 
			
            {"E\\", " "+IPA.sampa2ipa("E\\"), ""}, 
            {"i\\", " "+IPA.sampa2ipa("i\\"), ""}
        };

        /* diakritika */
        String[][]diacritics={
            {"_0", " "+IPA.sampa2ipa("_0"), "402A"}, 
            {"_v", " "+IPA.sampa2ipa("_v"), "403"}, 
            {"_h", " "+IPA.sampa2ipa("_h"), "404"},
            {"_t", " "+IPA.sampa2ipa("_t"), "405"}, 
            {"_k", " "+IPA.sampa2ipa("_k"), "406"}, 
            {"_N", " "+IPA.sampa2ipa("_N"), "407"}, 
            {"_d", " "+IPA.sampa2ipa("_d"), "408"}, 
            {"_a", " "+IPA.sampa2ipa("_a"), "409"}, 
            {"_m", " "+IPA.sampa2ipa("_m"), "410"}, 
            {"_O", " "+IPA.sampa2ipa("_O"), "411"}, 
            {"_c", " "+IPA.sampa2ipa("_c"), "412"}, 
            {"_+", " "+IPA.sampa2ipa("_+ "), "413"},
            {"_-", " "+IPA.sampa2ipa("_-"), "414"}, 
            {"_\"", " "+IPA.sampa2ipa("_\""), "415"}, 
            {"_x", " "+IPA.sampa2ipa("_x"), "416"}, 
            {"_A", " "+IPA.sampa2ipa("_A"), "417"}, 
            {"_q", " "+IPA.sampa2ipa("_q"), "418"}, 
            {"`", " "+IPA.sampa2ipa("`"), "419"}, 
            {"#", " "+IPA.sampa2ipa("#"), "419"}, 
            {"@`", " "+IPA.sampa2ipa("@`"), "327"}, 
            {"_w", " "+IPA.sampa2ipa("_w"), "420"}, 
            {"_j", " "+IPA.sampa2ipa("_j"), "421"}, 
            {"_G", " "+IPA.sampa2ipa("_G"), "422"}, 
            {"_?\\", " "+IPA.sampa2ipa("_?\\"), "423"}, 
            {"~", " "+IPA.sampa2ipa("~"), "424"}, 
            {"_n", " "+IPA.sampa2ipa("_n"), "425"}, 
            {"_l", " "+IPA.sampa2ipa("_l"), "426"}, 
            {"_}", " "+IPA.sampa2ipa("_}"), "427"}, 
            {"_e", " "+IPA.sampa2ipa("_e"), "428"}, 
            {"l_e", " "+IPA.sampa2ipa("l_e"), "209"}, 
            {"_r", " "+IPA.sampa2ipa("_r"), "429"}, 
            {"_o", " "+IPA.sampa2ipa("_o"), "430"}, 
            {"=", " "+IPA.sampa2ipa("=") ,"431"},
            {"_^", " "+IPA.sampa2ipa("_^"), "432"}, 

            {"_h\\", " "+IPA.sampa2ipa("_h\\"), ""}, 
            {"_y", " "+IPA.sampa2ipa("_y"), ""}, 
            {"_s", " "+IPA.sampa2ipa("_s"), ""}, 
            {"_x'", " "+IPA.sampa2ipa("_x'"), ""}, 
            {"_?", " "+IPA.sampa2ipa("_?"), ""}, 
            {"_?'", " "+IPA.sampa2ipa("_?'"), ""}, 
            {"_r\\", " "+IPA.sampa2ipa("_r\\"), ""}, 
            {"_r'", " "+IPA.sampa2ipa("_r'"), ""}, 
            {"_r\\'", " "+IPA.sampa2ipa("_r\\'"), ""}, 
            {"_R\\", " "+IPA.sampa2ipa("_R\\"), ""}, 
            {"dz", " "+IPA.sampa2ipa("dz"), ""}, 
            {"dZ", " "+IPA.sampa2ipa("dZ"), ""}, 
            {"dz\\", " "+IPA.sampa2ipa("dz\\"), ""}, 
            {"ts", " "+IPA.sampa2ipa("ts"), ""}, 
            {"tS", " "+IPA.sampa2ipa("tS"), ""}, 
            {"ts\\", " "+IPA.sampa2ipa("ts\\"), ""},
            /*
            {"fN", " "+IPA.sampa2ipa("fN"),"4"},
            {"ls\t", " "+IPA.sampa2ipa("ls"),"4"},
            {"lz\t", " "+IPA.sampa2ipa("lz"),"4"}
            */
        };

    private static void setupTable(JTable table) {
        DefaultTableCellRenderer renderer = new DefaultTableCellRenderer();
        renderer.setHorizontalAlignment(JLabel.CENTER);
        at.iem.tools.gui.AntiAliasing.enable(renderer);
        for(int i=0; i<table.getColumnModel().getColumnCount(); i++) {
            table.getColumnModel().getColumn(i).setCellRenderer(renderer);
        }
        table.setFont(AdabaShared.AdabaFONT);
    }

    static JFrame frame;

    public AdabaSAMPAhelp() {
        this(true);
    }

    public AdabaSAMPAhelp(boolean integrate_sampa2ipa) {
	if (frame!=null){
            frame.toFront();
            return;
        }
	frame = new JFrame(AdabaShared.getLabel("MenuHelpSAMPA"));
	JPanel pane  = new JPanel();
	pane.setLayout(new BoxLayout(pane, BoxLayout.X_AXIS));

	frame.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
		    frame=null;
		}
	    });

        String[]colnames={"SAMPA", "IPA", "#"};
        DefaultTableModel consonants_model = new DefaultTableModel( consonants, colnames);
	JTable konsonanten = new JTable(consonants_model);

        DefaultTableModel vowels_model = new DefaultTableModel( vowels, colnames);
	JTable vokale = new JTable(vowels_model);

        DefaultTableModel diacritics_model = new DefaultTableModel( diacritics, colnames);
	JTable diakritika = new JTable(diacritics_model);

        setupTable(konsonanten);
        setupTable(vokale);
        setupTable(diakritika);

        JScrollPane kPane = new JScrollPane(konsonanten);
        JScrollPane vPane = new JScrollPane(vokale);
        JScrollPane dPane = new JScrollPane(diakritika);


        pane.add(kPane);
        pane.add(vPane);
        pane.add(dPane);


        JPanel framepane = new JPanel();
	framepane.setLayout(new BoxLayout(framepane, BoxLayout.Y_AXIS));

        if(integrate_sampa2ipa) {
            framepane.add(new SampaConverter(false));
        }

        framepane.add(pane);

        frame.getContentPane().add(framepane);

        frame.pack();
        frame.setVisible(true);
        
        try {
            int height=konsonanten.getRowHeight();
            height=(int)(1.5*height);

            konsonanten.setRowHeight(height);
            vokale.setRowHeight(height);
            diakritika.setRowHeight(height);
        } catch (Exception e) {

        }
    }
}
