// AdabaSearchInterface.java
// $Id: AdabaSearchInterface.java 1389 2007-02-26 13:48:21Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

package at.iem.adaba;
import  at.iem.adaba.database.TranscriptionEintrag;

public interface AdabaSearchInterface {
    /**
     * get the results of a sub-search;
     * if the sub-search holds a sub-set of results it may return only this sub-set (e.g.: selection)
     * @param id the sub-search
     * @param all4none if a sub-search holds an empty sub-set of results, return all results (instead of the empty sub-set)
     * @return the results of a sub-search
     */
    String[]getResultFromSubSearch(int id, boolean all4none);

    /**
     * get the results of a sub-search;
     * @param id the sub-search
     * @return the results of a sub-search
     */
    String[]getResultFromSubSearch(int id);

    /**
     * get the results of the search;
     * if multiple sub-searches are present, get the "current" one
     * @return the results of a sub-search
     */
    String[]getResultFromSearch();
}
