// SampaConverter.java
// $Id: SampaConverter.java 1804 2007-06-26 19:58:00Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

// 03/10/2002

package at.iem.adaba;

import at.iem.tools.linguistic.IPA;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * help JFrame :: SAMPA2IPA-Tabelle
 */

public class SampaConverter extends JPanel implements ActionListener, KeyListener {
    private JTextField SAMPAfeld, IPAfeld;

    public SampaConverter() {    
        this(true);
    }

    public SampaConverter(boolean ownframe) {
        

	setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
	    //	Container pane = frame.getContentPane();

	JPanel SAMPApane = new JPanel();
	SAMPApane.setLayout(new BorderLayout());
	SAMPApane.setBorder(BorderFactory.createTitledBorder(
				     BorderFactory.createEmptyBorder(),
				     AdabaShared.getLabel("TitleSAMPApane")));
	JPanel IPApane = new JPanel();
	IPApane.setLayout(new BorderLayout());
	IPApane.setBorder(BorderFactory.createTitledBorder(
				   BorderFactory.createEmptyBorder(),
				   AdabaShared.getLabel("TitleIPApane")));

	SAMPAfeld = new JTextField(15);
	IPAfeld   = new JTextField(15);
        at.iem.tools.gui.AntiAliasing.enable(SAMPAfeld);
        at.iem.tools.gui.AntiAliasing.enable(IPAfeld);

	SAMPAfeld.setToolTipText(AdabaShared.getLabel("ToolTip_SAMPA"));
	  IPAfeld.setToolTipText(AdabaShared.getLabel("ToolTip_IPA"));

	SAMPAfeld.addActionListener(this);
	IPAfeld.addActionListener(this);

	SAMPAfeld.addKeyListener(this);
	IPAfeld.addKeyListener(this);

	SAMPAfeld.setFont(AdabaShared.AdabaFONT);
	IPAfeld.setFont(AdabaShared.AdabaFONT);

	SAMPApane.add(SAMPAfeld);
	IPApane.add(IPAfeld);

	add(SAMPApane);
	add(IPApane);


        if(ownframe) {
            JFrame frame = new JFrame("SAMPA <-> IPA");
            
            frame.getContentPane().add(this);
            frame.pack();
            frame.setVisible(true);
        }
    }

    private void doConversion(boolean sampa2ipa) {
        boolean fixMS = AdabaShared.fixMSFonts;
	IPA ipa=new IPA();
	if (sampa2ipa){
	    ipa.setSAMPA(SAMPAfeld.getText());
	    IPAfeld.setText(ipa.toStringMS(fixMS));
	} else {
	    ipa.setIPA(IPAfeld.getText());
            if(fixMS)ipa.fixMS2Unicode();
	    SAMPAfeld.setText(ipa.getSAMPA());
	}
    }

    public void actionPerformed(ActionEvent e){
        doConversion(e.getSource()==SAMPAfeld);
    }

    public void keyReleased(KeyEvent e) {
        doConversion(e.getSource()==SAMPAfeld);   
    }

    public void keyPressed(KeyEvent e) {}
    public void keyTyped(KeyEvent e) {}

      public static void main(String s[]) throws Exception {
	new SampaConverter(true);
    }  
    static final long serialVersionUID = 1L;
}
