// updateATD.java
// $Id: updateATD.java 1545 2007-05-16 19:28:16Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

/**
 * convertiert eine atd-datenbank in das neueste format
 */

package at.iem.adaba.database.ATD;
import at.iem.adaba.database.TranscriptionEintrag;
import java.io.File;
import org.w3c.tools.dbm.*;

public class updateATD {
    jdbm newDB, oldDB;

    public updateATD(File infile, File outfile) {
	try{
	    oldDB = new jdbm(infile);
	    newDB = new jdbm(outfile);
	} catch (Exception ex) {
	    at.iem.tools.Logger.println("couldn't open database-files!");
	    at.iem.tools.Logger.println(ex);
	    System.exit(-1);
	}
    
	at.iem.tools.Logger.println("umlaut-A = ");

	newDB.forceWriting(false);
	try {
	    java.util.Enumeration e = oldDB.keys();
	    while (e.hasMoreElements()){
		byte key_b[] = (byte[]) e.nextElement();
		if (key_b!=null && key_b.length>0) {
		    byte val[] = oldDB.lookup(key_b);
		    if (val!=null){
			String key;
			try {
			    key = new String(key_b, "UTF-8");
			} catch (Exception ex){
			    key = new String(key_b);
			    at.iem.tools.Logger.println("couldn't convert "+key+" to UTF-8");
			}
			at.iem.tools.Logger.println("konvertiere '"+key+"'  ('"+new String(key_b)+"')");
			ATDEintrag entry = new ATDEintrag(key, val);
			if (entry.getBinaryVersion()==0)
			    entry.setKey(new String(key_b)); /* stored in non UTF-8 (current locale!)*/
			byte[] key_utf8;
			try {
			    key_utf8=entry.getKey().getBytes("UTF-8");
			}  catch (Exception ex){
			    key_utf8 = entry.getKey().getBytes();
			    at.iem.tools.Logger.println("couldn't get entry "+key_utf8+" as UTF-8");
			}
			if(key_utf8!=null)newDB.store(key_utf8, entry.getBytes(), jdbm.STORE_REPLACE);
		    }
		}
	    }
	} catch (Exception ex) {
	    at.iem.tools.Logger.println("an error occured while converting the DB...");
	    at.iem.tools.Logger.println(ex);
	}

	try{
	    newDB.save();
	} catch (Exception ex) {
	    at.iem.tools.Logger.println("couldn't write new database!");
	    at.iem.tools.Logger.println(ex);
	    System.exit(-1);
	}
    }
    public updateATD(String ifile, String ofile) {
	File infile =  new File(ifile);
	File outfile = new File(ofile);
	if (!infile.exists())usage();
	if (outfile.exists())usage();

	new updateATD(infile, outfile);
    }
    
    private static void usage() {
	at.iem.tools.Logger.println("usage: updateATD infile.atd outfile.atd");
	System.exit(-1);
    }
    public static void main(String s[]) throws Exception {
	if (s.length<2)usage();
	new updateATD(s[0], s[1]);
    }
}
