// Exporter.java
// $Id: Exporter.java 1161 2007-01-02 15:50:12Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
//
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

package at.iem.adaba.database;


public interface Exporter {
    /** export a database to the implementor's native storage method;
     * no assumption is made on the order of the exported database entries
     * @param source the database to be exported
     * @return <code>true</code> on success, <code>false</code> otherwise
     * @throws ????
     */
    boolean exportFrom(TranscriptionDataBase source) throws Exception;
    /** export a selection of entries in the database to the implementor's native storage method;
     * the order of the exported entries is the same as the order of the exportKeys
     * @param source the database to be exported
     * @param exportKeys the keys to be exported
     * @return <code>true</code> on success, <code>false</code> otherwise
     */
    boolean exportFrom(TranscriptionDataBase source, java.lang.String[] exportKeys) throws Exception;
}
