// Importer.java
// $Id: Importer.java 1161 2007-01-02 15:50:12Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
//
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

package at.iem.adaba.database;

/*
 * LATER add a mask to only import certain data (overwriting existing sub-data)
 * LATER2 add a matching-mask to in/exclude certain entries
 */


public interface Importer {
    /** import a database to the implementor's native storage method;
     * no assumption is made on the order of the imported database entries
     * @param destination the database to be imported
     * @param overwrite overwrite existing entries
     * @return an array of keys to Eintrags that clashed
     */
    String[] importTo(TranscriptionDataBase destination, boolean overwrite) throws Exception;
}
