// Menu.java
// $Id: Menu.java 1862 2007-07-04 13:45:16Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

package at.iem.adaba.gui;
import  at.iem.adaba.database.*;
import  at.iem.adaba.*;
import at.iem.tools.*;

import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;

/**
 * die Kopfzeile der Applikation
 * einfache Funktionen wie Settings und Beenden
 */

public class Menu extends JMenuBar implements ActionListener, at.iem.tools.Selectable {
    at.iem.tools.gui.Refreshable parent;
    at.iem.tools.Selectable sel;

    public Menu() {
        this(null);
    }

    public Menu(at.iem.tools.gui.Refreshable parent) {
        JMenu    menu;
        JMenuItem menuItem;   
        JMenu submenu;

        this.parent = parent;
  
	menu = new JMenu(AdabaShared.getLabel("MenuFile"));
	add(menu);

        /*
        submenu = new JMenu(AdabaShared.getLabel("MenuFileExport"));
        menu.add(submenu);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuFileExportXML"));
	submenu.add(menuItem);
	menuItem.setActionCommand("exportXML");
	menuItem.addActionListener(this);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuFileExportTXT"));
	submenu.add(menuItem);
	menuItem.setActionCommand("exportTEXT");
	menuItem.addActionListener(this);
        */

        submenu = new JMenu(AdabaShared.getLabel("MenuEntrysExport"));
        menu.add(submenu);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuEntrysExportXML"));
	submenu.add(menuItem);
	menuItem.setActionCommand("list_exportXML");
	menuItem.addActionListener(this);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuEntrysExportTXT"));
	submenu.add(menuItem);
	menuItem.setActionCommand("list_exportTEXT");
	menuItem.addActionListener(this);

	menu.addSeparator();

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuFileQuit"));
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q, ActionEvent.CTRL_MASK));
	menu.add(menuItem);
	menuItem.setActionCommand("quit");
	menuItem.addActionListener(this);

	menu = new JMenu(AdabaShared.getLabel("MenuProperty"));
	add(menu);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuPropertyStandard"));
	//menuItem.setEnabled(false);
	menuItem.setActionCommand("configureDefault");
	menu.add(menuItem);
	menuItem.addActionListener(this);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuPropertyChange"));
	menu.add(menuItem);
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F4, 0));
	menuItem.setActionCommand("configure");
	menuItem.addActionListener(this);



	menu = new JMenu(AdabaShared.getLabel("MenuTools"));
	add(menu);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuHelpSAMPA2IPA"));
	menuItem.setActionCommand("sampa2ipa");
	menuItem.addActionListener(this);
	menu.add(menuItem);
	menuItem = new JMenuItem(AdabaShared.getLabel("MenuHelpSAMPA"));
	menu.add(menuItem);
	menuItem.setActionCommand("sampa");
	menuItem.addActionListener(this);
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F8, 0));
        
        menu.addSeparator();
	menuItem = new JMenuItem(AdabaShared.getLabel("MenuHelpIPAGroups"));
	menu.add(menuItem);
	menuItem.setActionCommand("ipagroups");
	menuItem.addActionListener(this);
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F9, 0));

	//add(Box.createHorizontalGlue());

	menu = new JMenu(AdabaShared.getLabel("MenuHelp"));
	add(menu);
        //setHelpMenu(menu);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuHelpIntro"));
	menuItem.setActionCommand("help_intro");
	menuItem.addActionListener(this);
	menuItem.setEnabled(true);
	menu.add(menuItem);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuHelpSearch"));
	menuItem.setActionCommand("help");
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F1, 0));
	menuItem.addActionListener(this);
	menuItem.setEnabled(true);
	menu.add(menuItem);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuHelpPhonetic"));
	menuItem.setActionCommand("help_phonetic");
	menuItem.addActionListener(this);
	menuItem.setEnabled(true);
	menu.add(menuItem);

        menu.addSeparator();

        submenu = new JMenu(AdabaShared.getLabel("MenuHelpLicense"));
        menu.add(submenu);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuHelpLicenseAdaba"));
	menuItem.setActionCommand("license_adaba");
	menuItem.addActionListener(this);
	submenu.add(menuItem);

 	menuItem = new JMenuItem(AdabaShared.getLabel("MenuHelpLicenseFont"));
	menuItem.setActionCommand("license_font");
	menuItem.addActionListener(this);
	submenu.add(menuItem);
    }

    public void actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();
        runCommand(cmd);
    }

    private void runCommand(String cmd) {
        Component c=null;
        if(cmd==null)return;
	if (cmd.equals("quit")){
            AdabaShared.exit();
	} else if (cmd.equals("exportXML")){
            TranscriptionDataBase dataBase=AdabaShared.getDB();
	    JFileChooser fc = new JFileChooser(".");
	    fc.setFileFilter(new at.iem.tools.gui.CustomFileFilter(AdabaShared.getLabel("FileXML"), ".xml"));
	    if (fc.showSaveDialog(c)==JFileChooser.APPROVE_OPTION){
		java.io.File fil = fc.getSelectedFile();
		if (!fil.getName().toLowerCase().endsWith(".xml")){
		    String fname=fil.getName()+".xml";
		    fil=new java.io.File(fil.getParent(), fname);
		}
		String warning = (fil.exists()?
				  StringX.replace(AdabaShared.getLabel("WarningOverwriteDB"),
						  "%s", fil.getName()):
				  StringX.replace(AdabaShared.getLabel("WarningSaveDB"),
						  "%s", fil.getName()));

		if (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(
						      c,
						      warning,

						      AdabaShared.getLabel("TitleExportXML"),
						      JOptionPane.YES_NO_OPTION,
						      JOptionPane.WARNING_MESSAGE)){
		     try {
			 at.iem.adaba.database.XML.XMLfile xmlfile=new  at.iem.adaba.database.XML.XMLfile(fil);
			 boolean ok=xmlfile.exportFrom(dataBase);
                        at.iem.tools.Logger.println("exported: "+ok);
                    } catch (Exception ex) {
                        at.iem.tools.Logger.println("an error occured: "+ex);
                    }
		    //dataBase.exportXML(fil, true); //  "true"==sorted; "false"=unsorted
		    JOptionPane.showMessageDialog(c,  
						  AdabaShared.getLabel("MessageExported"));
		}
	    }
	} else if (cmd.equals("exportTIPA")){
            TranscriptionDataBase dataBase=AdabaShared.getDB();
	    JFileChooser fc = new JFileChooser(".");
	    fc.setFileFilter(new at.iem.tools.gui.CustomFileFilter(AdabaShared.getLabel("FileTIPA"), ".tex"));
	    if (fc.showSaveDialog(c)==JFileChooser.APPROVE_OPTION){
		java.io.File fil = fc.getSelectedFile();
		if (!fil.getName().toLowerCase().endsWith(".tex")){
		    String fname=fil.getName()+".tex";
		    fil=new java.io.File(fil.getParent(), fname);
		}
		String warning = (fil.exists()?
				  StringX.replace(AdabaShared.getLabel("WarningOverwriteDB"),
						  "%s", fil.getName()):
				  StringX.replace(AdabaShared.getLabel("WarningSaveDB"),
						  "%s", fil.getName()));

		if (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(
						      c,
						      warning,

						      AdabaShared.getLabel("TitleExportTIPA"),
						      JOptionPane.YES_NO_OPTION,
						      JOptionPane.WARNING_MESSAGE)){
                    at.iem.adaba.database.TIPA.TIPAfile tipafile=new  at.iem.adaba.database.TIPA.TIPAfile(fil);
                    try {
                        boolean ok=tipafile.exportFrom(dataBase);
                        at.iem.tools.Logger.println("exported: "+ok);
                    } catch (Exception ex) {
                        at.iem.tools.Logger.println("an error occured: "+ex);
                    }
		    //dataBase.exportTIPA(fil, true); //  "true"==sorted; "false"=unsorted
		    JOptionPane.showMessageDialog(c,  
						  AdabaShared.getLabel("MessageExported"));
		}
	    }
	} else if (cmd.equals("exportSAMPA")){
            TranscriptionDataBase dataBase=AdabaShared.getDB();
	    JFileChooser fc = new JFileChooser(".");
	    fc.setFileFilter(new at.iem.tools.gui.CustomFileFilter(AdabaShared.getLabel("FileSAMPA"), ".txt"));
	    if (fc.showSaveDialog(c)==JFileChooser.APPROVE_OPTION){
		java.io.File fil = fc.getSelectedFile();
		if (!fil.getName().toLowerCase().endsWith(".txt")){
		    String fname=fil.getName()+".txt";
		    fil=new java.io.File(fil.getParent(), fname);
		}
		String warning = (fil.exists()?
				  StringX.replace(AdabaShared.getLabel("WarningOverwriteDB"),
						  "%s", fil.getName()):
				  StringX.replace(AdabaShared.getLabel("WarningSaveDB"),
						  "%s", fil.getName()));

		if (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(
						      c,
						      warning,
						      AdabaShared.getLabel("TitleExportSAMPA"),
						      JOptionPane.YES_NO_OPTION,
						      JOptionPane.WARNING_MESSAGE)){
		    Object[] possibilities = new Object[AdabaShared.region.length+1];
		    possibilities[0]=AdabaShared.getLabel("LabelStandardTranscription");
		    for (int i=1; i<possibilities.length; i++)possibilities[i]=AdabaShared.region[i-1][1];
		    String s = (String)JOptionPane.showInputDialog(
					c,
					AdabaShared.getLabel("MessageExportSampaRegion"),
					AdabaShared.getLabel("MessageSampaRegionTitle"),
					JOptionPane.PLAIN_MESSAGE,
					null,
					possibilities,
					AdabaShared.getLabel("LabelStandardTranscription"));
		
		    //If a string was returned, say so.
		    if(s==null || "".equals(s))s="";
                    String index=null;
		    for (int i=0; i<AdabaShared.region.length; i++)
			if(s.equals(AdabaShared.region[i][1])){
                            index=AdabaShared.region[i][0];
			    break;
			}
		    dataBase.exportSAMPA(fil, index);
		}
	    }
	} else if (cmd.equals("exportTEXT")){
            TranscriptionDataBase dataBase=AdabaShared.getDB();
	    JFileChooser fc = new JFileChooser(".");
	    fc.setFileFilter(new at.iem.tools.gui.CustomFileFilter(AdabaShared.getLabel("FileTXT"), ".txt"));
	    if (fc.showSaveDialog(c)==JFileChooser.APPROVE_OPTION){
		java.io.File fil = fc.getSelectedFile();
		if (!fil.getName().toLowerCase().endsWith(".txt")){
		    String fname=fil.getName()+".txt";
		    fil=new java.io.File(fil.getParent(), fname);
		}
		String warning = (fil.exists()?
				  StringX.replace(AdabaShared.getLabel("WarningOverwriteDB"),
						  "%s", fil.getName()):
				  StringX.replace(AdabaShared.getLabel("WarningSaveDB"),
						  "%s", fil.getName()));

		if (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(
						      c,
						      warning,
						      AdabaShared.getLabel("TitleExportTXT"),
						      JOptionPane.YES_NO_OPTION,
						      JOptionPane.WARNING_MESSAGE)){
                    at.iem.adaba.database.TXT.TXTfile txtfile=new  at.iem.adaba.database.TXT.TXTfile(fil);
                    try {
                        boolean ok=txtfile.exportFrom(dataBase);
                        at.iem.tools.Logger.println("exported: "+ok);
                    } catch (Exception ex) {
                        at.iem.tools.Logger.println("an error occured: "+ex);
                    }
		}
	    }

	} else if (cmd.equals("list_exportXML")){
            String keys[]=null;
            if(sel!=null){
                Object[]okeys=sel.getSelection();
                if(okeys!=null && okeys.length>0){
                    keys=new String[okeys.length];
                    for(int i=0; i<okeys.length; i++) {
                        if(okeys[i]==null)keys[i]=null;
                        else
                            keys[i]=okeys[i].toString();
                    }
                }
            }
            if(keys==null) {
                JOptionPane.showMessageDialog(c,  
                                              AdabaShared.getLabel("ErrorExportEmptyList"), null, JOptionPane.ERROR_MESSAGE);
                return;
            }
            
            TranscriptionDataBase dataBase=AdabaShared.getDB();
	    JFileChooser fc = new JFileChooser(".");
	    fc.setFileFilter(new at.iem.tools.gui.CustomFileFilter(AdabaShared.getLabel("FileXML"), ".xml"));
	    if (fc.showSaveDialog(c)==JFileChooser.APPROVE_OPTION){
		java.io.File fil = fc.getSelectedFile();
		if (!fil.getName().toLowerCase().endsWith(".xml")){
		    String fname=fil.getName()+".xml";
		    fil=new java.io.File(fil.getParent(), fname);
		}
		String warning = (fil.exists()?
				  StringX.replace(AdabaShared.getLabel("WarningOverwriteDB"),
						  "%s", fil.getName()):
				  StringX.replace(AdabaShared.getLabel("WarningSaveDB"),
						  "%s", fil.getName()));

		if (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(
						      c,
						      warning,

						      AdabaShared.getLabel("TitleExportXML"),
						      JOptionPane.YES_NO_OPTION,
						      JOptionPane.WARNING_MESSAGE)){
                    try {
                        at.iem.adaba.database.XML.XMLfile xmlfile=new  at.iem.adaba.database.XML.XMLfile(fil);
                        boolean ok=xmlfile.exportFrom(dataBase, keys);
                        at.iem.tools.Logger.println("exportedxml: "+ok);
                    } catch (Exception ex) {
                        at.iem.tools.Logger.println("an error occured: "+ex);
                    }
		    //dataBase.exportXML(fil, true); //  "true"==sorted; "false"=unsorted
		    JOptionPane.showMessageDialog(c,  
						  AdabaShared.getLabel("MessageExported"));
		}
	    }
	} else if (cmd.equals("list_exportTEXT")){
            String keys[]=null;
            if(sel!=null){
                Object[]okeys=sel.getSelection();
                if(okeys!=null && okeys.length>0){
                    keys=new String[okeys.length];
                    for(int i=0; i<okeys.length; i++) {
                        if(okeys[i]==null)keys[i]=null;
                        else
                            keys[i]=okeys[i].toString();
                    }
                }
            }
            if(keys==null) {
                JOptionPane.showMessageDialog(c,  
                                              AdabaShared.getLabel("ErrorExportEmptyList"), null, JOptionPane.ERROR_MESSAGE);
                return;
            }

            TranscriptionDataBase dataBase=AdabaShared.getDB();
	    JFileChooser fc = new JFileChooser(".");
	    fc.setFileFilter(new at.iem.tools.gui.CustomFileFilter(AdabaShared.getLabel("FileTXT"), ".txt"));
	    if (fc.showSaveDialog(c)==JFileChooser.APPROVE_OPTION){
		java.io.File fil = fc.getSelectedFile();
		if (!fil.getName().toLowerCase().endsWith(".txt")){
		    String fname=fil.getName()+".txt";
		    fil=new java.io.File(fil.getParent(), fname);
		}
		String warning = (fil.exists()?
				  StringX.replace(AdabaShared.getLabel("WarningOverwriteDB"),
						  "%s", fil.getName()):
				  StringX.replace(AdabaShared.getLabel("WarningSaveDB"),
						  "%s", fil.getName()));

		if (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(
						      c,
						      warning,
						      AdabaShared.getLabel("TitleExportTXT"),
						      JOptionPane.YES_NO_OPTION,
						      JOptionPane.WARNING_MESSAGE)){
                    try {
                        at.iem.adaba.database.TXT.TXTfile txtfile=new  at.iem.adaba.database.TXT.TXTfile(fil);
                        boolean ok=txtfile.exportFrom(dataBase, keys);
                        at.iem.tools.Logger.println("exportedtxt: "+ok);
                    } catch (Exception ex) {
                        at.iem.tools.Logger.println("an error occured: "+ex);
                    }
		}
	    }



	} else if (cmd.equals("exportTXT")) { /* just a dummy that exports to "/tmp" */
            TranscriptionDataBase dataBase=AdabaShared.getDB();
            if(dataBase!=null) {
                at.iem.adaba.database.TXT.TXTfile txtfile=new  at.iem.adaba.database.TXT.TXTfile(new java.io.File("/tmp/adaba.txt"));
                try {
                    
                    boolean ok=txtfile.exportFrom(dataBase);
                    at.iem.tools.Logger.println("exported: "+ok);
                } catch (Exception ex) {
                    at.iem.tools.Logger.println("an error occured: "+ex);
                }
            }
	} else if (cmd.equals("configure")) {
	    new at.iem.adaba.transcriber.TransProperties();
	    if(null!=parent)
                parent.refresh();
	} else if (cmd.equals("configureDefault")) {
            if (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(this,
                                                      AdabaShared.getLabel("WarningConfigureDefault"),
						      AdabaShared.getLabel("TitleConfigureDefault"),
						      JOptionPane.YES_NO_OPTION,
						      JOptionPane.WARNING_MESSAGE)){
                    AdabaShared.clear();
                }
            
	} else if (cmd.equals("license_adaba")){
            at.iem.tools.Logger.println("menu width: "+this.getSize());
            java.net.URL url=ClassLoader.getSystemResource("resources/licenses/GPL-2");
            new at.iem.tools.gui.TextWindow(url, AdabaShared.getLabel("MenuHelpLicenseAdaba"), 
                                            AdabaShared.getLabel("MenuHelpLicenseAccepted"), null, true);
	    //new at.iem.tools.GnuGPL(true);
	} else if (cmd.equals("license_font")){
            java.net.URL url=ClassLoader.getSystemResource("resources/licenses/SIL_OpenFontLicense.txt");
            new at.iem.tools.gui.TextWindow(url, AdabaShared.getLabel("MenuHelpLicenseFont"), 
                                            AdabaShared.getLabel("MenuHelpLicenseAccepted"), null, true);
	} else if (cmd.equals("sampa2ipa")){
	    new at.iem.adaba.SampaConverter();
	} else if (cmd.equals("sampa")){
	    new AdabaSAMPAhelp();
        } else if (cmd.equals("ipagroups")) {
            // IPAgroups
            showIPAgroups();
	} else if (cmd.equals("help")){
            openHelp("search");
	} else if (cmd.equals("help_intro")){
            openHelp("intro");
	} else if (cmd.equals("help_phonetic")){
            openHelp("phonetic");
        } else {
	    at.iem.tools.Logger.println("adaba:gui:Menu:: I do not know, what to do!!!!");
	}
    }
    private at.iem.tools.gui.TextWindow helpwindow;
    private void openHelp(String id) {
        String helpres=null;
        if(id.equals("search")) {
            helpres="resources/texts/hilfe2.htm";
        } else if(id.equals("intro")) {
            helpres="resources/texts/hilfe1.htm";
        } else if(id.equals("phonetic")) {
            helpres="resources/texts/hilfe3.htm";
        } else {
            helpres="resources/texts/hilfe2.htm";
        }

        java.net.URL url=ClassLoader.getSystemResource(helpres);
        if(helpwindow==null) {
            helpwindow=new at.iem.tools.gui.TextWindow(url, AdabaShared.getLabel("MenuHelp"), 
                                            AdabaShared.getLabel("ButtonDone"), null, false);
        } else {
            helpwindow.setURL(url);
        }
    }
    

    private class PropTableModel extends DefaultTableModel {
        int[]editable_columns;
        PropTableModel(String[][] data, String[]header, int[]editable_columns) {
            super(data, header);
            this.editable_columns=editable_columns;
        }
        public boolean isCellEditable(int row, int col) {
            if(editable_columns==null||editable_columns.length<1)
                return true;
            
            for(int i=0; i<editable_columns.length; i++) {
                if (col==editable_columns[i])
                    return true;
            }
            return false;
        }
    }

    private JFrame ipagroups_frame = null;
    private void hideIPAgroups() {
        if(null==ipagroups_frame)
            return;

        ipagroups_frame.dispose();
        
    }
    private void showIPAgroups() {
        if(null!=ipagroups_frame){
            ipagroups_frame.toFront();
            return;
        }
        ipagroups_frame = new JFrame(AdabaShared.getLabel("MenuHelpIPAGroups"));
        
        String[][]chars_=AdabaShared.getIPAgroupReplacement();

        String[][]chars =new String[chars_.length][3];
        for(int i=0; i<chars.length; i++){
            chars[i][0]=AdabaShared.getLabel("PropertiesChar_"+chars_[i][0]);
            chars[i][1]=chars_[i][1];
            chars[i][2]=at.iem.tools.StringX.merge(at.iem.tools.linguistic.IPA.getGroup(chars_[i][0]), " ");
        }
	
        DefaultTableModel characters_model = new PropTableModel(chars,
                                                                new String[]{AdabaShared.getLabel("PropertiesCharTableGroup"), 
                                                                             AdabaShared.getLabel("PropertiesCharTableAbbrev"),
                                                                             AdabaShared.getLabel("PropertiesCharTableChars"),
                                                                },
                                                                new int[]{-1});
        JTable characters_table = new JTable(characters_model);
        //characters_table.setFont( AdabaShared.AdabaFONT.deriveFont( characters_table.getFont().getSize2D()) );
        characters_table.setFont( AdabaShared.AdabaFONT);
        characters_table.setRowHeight((int)(1.5* characters_table.getRowHeight()));
        DefaultTableCellRenderer renderer = new DefaultTableCellRenderer();
        renderer.setHorizontalAlignment(JLabel.CENTER);
        at.iem.tools.gui.AntiAliasing.enable(renderer);
        for(int i=0; i<characters_table.getColumnModel().getColumnCount(); i++) {
            characters_table.getColumnModel().getColumn(i).setCellRenderer(renderer);
        }
        //            table.setFont(AdabaShared.AdabaFONT);

        JScrollPane scrollPane = new JScrollPane(characters_table);
        JPanel pane  = new JPanel();
        pane.setLayout(new BoxLayout(pane, BoxLayout.X_AXIS));
        pane.add(scrollPane);

        ipagroups_frame.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    ipagroups_frame = null;
                }
            });

        ipagroups_frame.getContentPane().add(pane);
            
        ipagroups_frame.pack();
        ipagroups_frame.setVisible(true);
    }

    public void setEntrySelector(at.iem.tools.Selectable s) {
        sel=s;
    }


    public Object[]getSelection() {
        return null;
    }
    public int getSelectedIndex() {
        return -1;
    }
    public void setSelectedIndex(int i) {}

    public void setSelected(String id) {
        if(id==null)return;
        openHelp(id);
    }

    /* for serialization */
    private static final long serialVersionUID = 1L;
}
