// Text.java
// $Id: Text.java 831 2006-03-16 16:21:53Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

package at.iem.adaba.gui;

import javax.swing.*;
import javax.swing.event.HyperlinkListener;
import javax.swing.event.HyperlinkEvent;

/**
 * die META-Klasse fr das Text
 */

public class Text extends JPanel implements HyperlinkListener {
    JEditorPane editorPane;


    private boolean playing;
    private ImageIcon playicon, pauseicon;
    private java.net.URL url;

    public Text(String file) {
        setLayout(new BoxLayout(this, BoxLayout.X_AXIS));

        //java.net.URL url = TextSamplerDemo.class.getResource("TextSamplerDemoHelp.html");
        java.net.URL url=ClassLoader.getSystemResource(file);
        try {
            if(null==url) url = new java.net.URL(file);
        } catch (java.net.MalformedURLException e) {
            at.iem.tools.Logger.println("bad URLname:" + file);
            url=null;
        }

        open(url);
        editorPane.setEditable(false);
        at.iem.tools.gui.AntiAliasing.enable(editorPane);
        editorPane.addHyperlinkListener(this);

        JScrollPane editorScrollPane = new JScrollPane(editorPane);
        editorScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        editorScrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
        editorScrollPane.setMinimumSize(new java.awt.Dimension(10, 10));

        //editorScrollPane.setPreferredSize(new java.awt.Dimension(250, 10000));
        add(editorScrollPane);
    }

    public boolean open(java.net.URL url) {
        this.url=null;

        if(editorPane==null)
            editorPane = new JEditorPane();

        editorPane.setFont(at.iem.adaba.AdabaShared.AdabaFONT);

        if(null==url) {
            at.iem.tools.Logger.println("no URL given for elan.Text");
            return false;
        }

        at.iem.tools.Logger.println("reading URL: " + url);


        try {
            editorPane.setPage(url);
        } catch (java.io.IOException e) {
            at.iem.tools.Logger.println("Attempted to read a bad URL: " + url);
            return false;
        }
        this.url=url;
        return true;
    }

    private void playSound(java.net.URL url) {
        at.iem.tools.sound.SoundPlayer player = new  at.iem.tools.sound.SoundPlayer();
        player.load(url);
        player.play();
    }

    private void clicked(java.net.URL url) {
        at.iem.tools.Logger.println("open URL: " + url);
        if(null==url||null==this.url)
            return;

        if(url.sameFile(this.url) && !url.equals(this.url)) {
            /* this is a local reference (e.g. "#A") */
            String ref=url.getRef();
            at.iem.tools.Logger.println("open anchor: " + ref);
            if(ref.startsWith("#tab#")) {
                if(parent!=null)
                    parent.setSelected(ref.substring(5));
                return;
            }
            if(ref.startsWith("#help#")) {
                if(help!=null)
                    help.setSelected(ref.substring(6));
                return;
            }

            try {
                editorPane.setPage(url);
            } catch (Exception ex) {
                at.iem.tools.Logger.println("URI-exception: "+ex);
            }
            return;
        }
    }

    public void hyperlinkUpdate(HyperlinkEvent e) {
        HyperlinkEvent.EventType typ=e.getEventType();
        if(typ==HyperlinkEvent.EventType.ACTIVATED) {
            clicked(e.getURL());
        } else if(typ==HyperlinkEvent.EventType.ENTERED) {
            //clicked(e.getURL());
        } else if (typ==HyperlinkEvent.EventType.EXITED) {

        }
    }
    at.iem.tools.Selectable parent=null;
    public void setParent(at.iem.tools.Selectable p) {
        parent=p;
    }
    at.iem.tools.Selectable help=null;
    public void setHelp(at.iem.tools.Selectable h) {
        help=h;
    }

    /* for serialization */
    private static final long serialVersionUID = 1L;

}
