// TransMenu.java
// $Id: TransMenu.java 1963 2008-06-03 14:29:03Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

package at.iem.adaba.transcriber;
import at.iem.adaba.database.*;
import at.iem.adaba.*;

import javax.swing.*;
import javax.swing.text.*;

import java.awt.*;
import java.awt.event.*;
import java.io.File;
import at.iem.tools.*;

/**
 * die Kopfzeile der Applikation
 * einfache Funktionen wie Settings und Beenden
 */

public class TransMenu extends JMenuBar implements ActionListener {
    private TransGUI parent;
    private JMenu    menu;
    private JMenuItem menuItem;
    private TranscriptionDataBase dataBase;

    /** 
     * creates a new Transcriber Menu
     * @param tg the TransGUI we are associated with
     * LATER change this to an interface...
     */
    public TransMenu(TransGUI tg) {
	parent = tg;
	dataBase = tg.dataBase;
	//menu = new JMenu(TransLabels.Mfile);
	menu = new JMenu(AdabaShared.getLabel("MenuFile"));
	add(menu);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuFileLoad"));
	menuItem.setAccelerator(KeyStroke.getKeyStroke(
		       KeyEvent.VK_O, ActionEvent.CTRL_MASK));
	menu.add(menuItem);
	menuItem.setActionCommand("load");
	menuItem.addActionListener(this);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuFileSave"));
	menuItem.setAccelerator(KeyStroke.getKeyStroke(
		       KeyEvent.VK_S, ActionEvent.CTRL_MASK));
	menu.add(menuItem);
	menuItem.setActionCommand("save");
	menuItem.addActionListener(this);

	menu.addSeparator();

        JMenu submenu = new JMenu(AdabaShared.getLabel("MenuFileImport"));
        menu.add(submenu);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuFileImportATD"));
	menuItem.setAccelerator(KeyStroke.getKeyStroke(
		       KeyEvent.VK_I, ActionEvent.CTRL_MASK));
	submenu.add(menuItem);
	menuItem.setActionCommand("import");
	menuItem.addActionListener(this);
	//	menuItem.setEnabled(false);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuFileImportXML"));
	submenu.add(menuItem);
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_I, ActionEvent.CTRL_MASK|ActionEvent.SHIFT_MASK));
	menuItem.setActionCommand("importXML");
	menuItem.addActionListener(this);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuFileImportSAMPA"));
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_I, ActionEvent.ALT_MASK));
	menuItem.setActionCommand("importSampa");
	menuItem.addActionListener(this);
	submenu.add(menuItem);


	menuItem = new JMenuItem(AdabaShared.getLabel("MenuFileImportTXT"));
	menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_I, ActionEvent.ALT_MASK|ActionEvent.SHIFT_MASK));
	menuItem.setActionCommand("importTxt");
	menuItem.addActionListener(this);
	submenu.add(menuItem);

        submenu = new JMenu(AdabaShared.getLabel("MenuFileExport"));
        menu.add(submenu);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuFileExportATD"));
	submenu.add(menuItem);
	menuItem.setActionCommand("exportATD");
	menuItem.addActionListener(this);
        /*
	menuItem = new JMenuItem("legacy ATD export");
	submenu.add(menuItem);
	menuItem.setActionCommand("exportATD_old");
	menuItem.addActionListener(this);
        */
	menuItem = new JMenuItem(AdabaShared.getLabel("MenuFileExportXML"));
	submenu.add(menuItem);
	menuItem.setActionCommand("exportXML");
	menuItem.addActionListener(this);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuFileExportSAMPA"));
	submenu.add(menuItem);
	menuItem.setActionCommand("exportSAMPA");
	menuItem.addActionListener(this);


	menuItem = new JMenuItem(AdabaShared.getLabel("MenuFileExportTXT"));
	submenu.add(menuItem);
	menuItem.setActionCommand("exportTEXT");
	menuItem.addActionListener(this);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuFileExportTIPA"));
	submenu.add(menuItem);
	menuItem.setActionCommand("exportTIPA");
	menuItem.addActionListener(this);
	//menuItem.setEnabled(false);


	menu.addSeparator();

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuFileDBinfo"));
	menu.add(menuItem);
	menuItem.setActionCommand("DBinfo");
	menuItem.addActionListener(this);
	menuItem = new JMenuItem(AdabaShared.getLabel("MenuFileShowText"));
	menu.add(menuItem);
	menuItem.setActionCommand("showText");
	menuItem.addActionListener(this);

	menu.addSeparator();
	menuItem = new JMenuItem(AdabaShared.getLabel("MenuFileQuit"));
	menuItem.setAccelerator(KeyStroke.getKeyStroke(
		       KeyEvent.VK_Q, ActionEvent.CTRL_MASK));
	menu.add(menuItem);
	menuItem.setActionCommand("quit");
	menuItem.addActionListener(this);

	menu = new JMenu(AdabaShared.getLabel("MenuEntry"));
	add(menu);
	
	menuItem = new JMenuItem(AdabaShared.getLabel("MenuEntryInsert"));
	menuItem.setAccelerator(KeyStroke.getKeyStroke(
		       KeyEvent.VK_N, ActionEvent.ALT_MASK));
	menuItem.setActionCommand("entryinsert");
	menuItem.addActionListener(this);
	menu.add(menuItem);
	menuItem = new JMenuItem(AdabaShared.getLabel("MenuEntryDelete"));
	menuItem.setActionCommand("entrydelete");
	menuItem.addActionListener(this);
	menu.add(menuItem);

	menu = new JMenu(AdabaShared.getLabel("MenuEntrys"));
	add(menu);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuEntrysExportATD"));
	menuItem.setActionCommand("entrysexport");
	menuItem.addActionListener(this);
	menu.add(menuItem);
	menuItem = new JMenuItem(AdabaShared.getLabel("MenuEntrysExportSAMPA"));
	menuItem.setActionCommand("entrysexportSAMPA");
	menuItem.addActionListener(this);
	menu.add(menuItem);
	menu.addSeparator();

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuEntrysDelete"));
	menuItem.setActionCommand("entrysdelete");
	menuItem.addActionListener(this);
	menu.add(menuItem);


	menu = new JMenu(AdabaShared.getLabel("MenuProperty"));
	add(menu);

	menuItem = new JMenuItem(AdabaShared.getLabel("MenuPropertyChange"));
	menuItem.setActionCommand("properties");
	menuItem.addActionListener(this);
	menu.add(menuItem);

	menuItem = new JMenuItem(AdabaShared.getLabel("SearchLabelEintrag"));
	menuItem.setActionCommand("extendedsearch");
	menuItem.addActionListener(this);
	menu.add(menuItem);
	//menu.addSeparator();

	add(Box.createHorizontalGlue());


	menu = new JMenu(AdabaShared.getLabel("MenuHelp"));
	//	menu.setEnabled(false);
	add(menu);
	menuItem = new JMenuItem(AdabaShared.getLabel("MenuHelp"));
	menuItem.setEnabled(false);
	menu.add(menuItem);
	menuItem = new JMenuItem(AdabaShared.getLabel("MenuHelpAbout"));
	menu.add(menuItem);
	menuItem.setActionCommand("about");
	menuItem.addActionListener(this);
	menuItem = new JMenuItem(AdabaShared.getLabel("MenuHelpSAMPA"));
	menu.add(menuItem);
	menuItem.setActionCommand("sampa");
	menuItem.addActionListener(this);
     }

    /**
     * user interaction
     */
    public void actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();
	if (cmd.equals("quit")){
	    dataBase.save();
	    System.exit(0);
	} else if (cmd.equals("importSampa")){
	    JFileChooser fc = new JFileChooser(".");
	    fc.setFileFilter(new at.iem.tools.gui.CustomFileFilter(AdabaShared.getLabel("FileSAMPA")+" (*.txt)", 
							       ".txt"));
	    if (fc.showOpenDialog(parent)==JFileChooser.APPROVE_OPTION){
		Object[] possibilities = new Object[AdabaShared.region.length+1];
		possibilities[0]=AdabaShared.getLabel("LabelStandardTranscription");
		for (int i=1; i<possibilities.length; i++)possibilities[i]=AdabaShared.region[i-1][1];
		String s = (String)JOptionPane.showInputDialog(
					parent,
					AdabaShared.getLabel("MessageImportSampaRegion"),
					AdabaShared.getLabel("MessageSampaRegionTitle"),
					JOptionPane.PLAIN_MESSAGE,
					null,
					possibilities,
					AdabaShared.getLabel("LabelStandardTranscription"));
		
		//If a string was returned, say so.
		if(s==null || "".equals(s))s="";
		String index=null;
		for (int i=0; i<AdabaShared.region.length; i++)
		    if(s.equals(AdabaShared.region[i][1])){
			index=AdabaShared.region[i][0];
			break;
		    }
		dataBase.importSAMPA(fc.getSelectedFile(), index);
	    }
	} else if (cmd.equals("importTxt")){
	    JFileChooser fc = new JFileChooser(".");
	    fc.setFileFilter(new at.iem.tools.gui.CustomFileFilter(AdabaShared.getLabel("FileTXT")+" (*.txt)", 
							       ".txt"));
	    if (fc.showOpenDialog(parent)==JFileChooser.APPROVE_OPTION){
		dataBase.importTXT(fc.getSelectedFile());
	    }
	} else if (cmd.equals("DBinfo")){
	    String[] buffi = dataBase.getAllEntries();
	    String details=new String("");
	    int count = buffi.length;
	    int i=0;
            int empty=0;
	    while(i++<count){
                if(buffi[i-1]==null || buffi[i-1].length()<1){
                    empty++;
                } else {
                    details+=buffi[i-1];
                    if (i<count)details+="\n";
                }
	    }
	    String text=AdabaShared.getLabel("MessageDBNumEntries");
	    text=StringX.replace(text, "%s", dataBase.getName());
	    text=StringX.replace(text, "%d", ""+(count-empty));


	    AdabaMessages.showMessageDetails(text,
					     details);
	    
	} else if (cmd.equals("showText")){
	    JTextArea textArea = new JTextArea(dataBase.toText());
	    textArea.setEditable(false);
	    JScrollPane areaScrollPane = new JScrollPane(textArea);
	    areaScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
	    areaScrollPane.setPreferredSize(new Dimension(1250, 1250));
	    JFrame frame = new JFrame(AdabaShared.getLabel("TitleExportText"));
	    frame.getContentPane().add(areaScrollPane);
	    frame.pack();
	    frame.setVisible(true);
	} else if (cmd.equals("load")){
	    if (JOptionPane.YES_OPTION ==
		JOptionPane.showConfirmDialog(parent,
					      AdabaShared.getLabel("MessageNewDB"),
					      AdabaShared.getLabel("TitleLoading"),
					      JOptionPane.YES_NO_OPTION,
					      JOptionPane.WARNING_MESSAGE)){
		JFileChooser fc = new JFileChooser(".");
		fc.setFileFilter(new at.iem.tools.gui.CustomFileFilter(AdabaShared.getLabel("FileATD"),
								   ".atd"));
		boolean file_loaded=false;
		while(!file_loaded){
		    if (fc.showOpenDialog(parent)==JFileChooser.APPROVE_OPTION){
			File fil=fc.getSelectedFile();
			if (!fil.exists()){
			    if (!fil.getName().toLowerCase().endsWith(".atd")){
				fil = new File(fil.getParent(), fil.getName()+".atd");
			    }	
			}
			file_loaded=dataBase.load(fil);
			if (!file_loaded){
			    file_loaded=(JOptionPane.NO_OPTION ==
				 JOptionPane.showConfirmDialog(
				       parent,
				       AdabaShared.getLabel("ErrorLoad"),
				       AdabaShared.getLabel("TitleLoadError"),
				       JOptionPane.YES_NO_OPTION,
				       JOptionPane.WARNING_MESSAGE));
			}
			if (fil!=null)parent.setTitle(fil.toString());
		    }
		}
	    }
	} else if (cmd.equals("save")){
	    dataBase.save();
	    JOptionPane.showMessageDialog(parent,  AdabaShared.getLabel("MessageSaved"));
	} else if (cmd.equals("exportATD_old")){
	    JFileChooser fc = new JFileChooser(".");
	    fc.setFileFilter(new at.iem.tools.gui.CustomFileFilter(AdabaShared.getLabel("FileATD"), ".atd"));
	    if (fc.showSaveDialog(parent)==JFileChooser.APPROVE_OPTION){
		java.io.File fil = fc.getSelectedFile();
		if (!fil.getName().toLowerCase().endsWith(".atd")){
		    String fname=fil.getName()+".atd";
		    fil=new java.io.File(fil.getParent(), fname);
		}
		String warning = (fil.exists()?
				  StringX.replace(AdabaShared.getLabel("WarningOverwriteDB"),
						  "%s", fil.getName()):
				  StringX.replace(AdabaShared.getLabel("WarningSaveDB"),
						  "%s", fil.getName()));

		if (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(
						      parent,
						      warning,

						      AdabaShared.getLabel("TitleExportATD"),
						      JOptionPane.YES_NO_OPTION,
						      JOptionPane.WARNING_MESSAGE)){
		    dataBase.exportATD(fil);
		    JOptionPane.showMessageDialog(parent,  
						  AdabaShared.getLabel("MessageExported"));
		}
	    }
	} else if (cmd.equals("exportATD")){
	    JFileChooser fc = new JFileChooser(".");
	    fc.setFileFilter(new at.iem.tools.gui.CustomFileFilter(AdabaShared.getLabel("FileATD"), ".atd"));
	    if (fc.showSaveDialog(parent)==JFileChooser.APPROVE_OPTION){
		java.io.File fil = fc.getSelectedFile();
		if (!fil.getName().toLowerCase().endsWith(".atd")){
		    String fname=fil.getName()+".atd";
		    fil=new java.io.File(fil.getParent(), fname);
		}
		String warning = (fil.exists()?
				  StringX.replace(AdabaShared.getLabel("WarningOverwriteDB"),
						  "%s", fil.getName()):
				  StringX.replace(AdabaShared.getLabel("WarningSaveDB"),
						  "%s", fil.getName()));

		if (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(
						      parent,
						      warning,

						      AdabaShared.getLabel("TitleExportATD"),
						      JOptionPane.YES_NO_OPTION,
						      JOptionPane.WARNING_MESSAGE)){
		     try {
			 at.iem.adaba.database.ATD.ATDataBase atdfile=new  at.iem.adaba.database.ATD.ATDataBase(fil, false);
			 boolean ok=atdfile.exportFrom(dataBase);
                        at.iem.tools.Logger.println("exported: "+ok);
                    } catch (Exception ex) {
                        at.iem.tools.Logger.println("an error occured: "+ex);
                    }
		    JOptionPane.showMessageDialog(parent,  
						  AdabaShared.getLabel("MessageExported"));
		}
	    }
	} else if (cmd.equals("exportXML")){
	    JFileChooser fc = new JFileChooser(".");
	    fc.setFileFilter(new at.iem.tools.gui.CustomFileFilter(AdabaShared.getLabel("FileXML"), ".xml"));
	    if (fc.showSaveDialog(parent)==JFileChooser.APPROVE_OPTION){
		java.io.File fil = fc.getSelectedFile();
		if (!fil.getName().toLowerCase().endsWith(".xml")){
		    String fname=fil.getName()+".xml";
		    fil=new java.io.File(fil.getParent(), fname);
		}
		String warning = (fil.exists()?
				  StringX.replace(AdabaShared.getLabel("WarningOverwriteDB"),
						  "%s", fil.getName()):
				  StringX.replace(AdabaShared.getLabel("WarningSaveDB"),
						  "%s", fil.getName()));

		if (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(
						      parent,
						      warning,

						      AdabaShared.getLabel("TitleExportXML"),
						      JOptionPane.YES_NO_OPTION,
						      JOptionPane.WARNING_MESSAGE)){
		     try {
			 at.iem.adaba.database.XML.XMLfile xmlfile=new  at.iem.adaba.database.XML.XMLfile(fil);
			 boolean ok=xmlfile.exportFrom(dataBase);
                        at.iem.tools.Logger.println("exported: "+ok);
                    } catch (Exception ex) {
                        at.iem.tools.Logger.println("an error occured: "+ex);
                    }
		    //dataBase.exportXML(fil, true); //  "true"==sorted; "false"=unsorted
		    JOptionPane.showMessageDialog(parent,  
						  AdabaShared.getLabel("MessageExported"));
		}
	    }
	} else if (cmd.equals("exportTIPA")){
	    JFileChooser fc = new JFileChooser(".");
	    fc.setFileFilter(new at.iem.tools.gui.CustomFileFilter(AdabaShared.getLabel("FileTIPA"), ".tex"));
	    if (fc.showSaveDialog(parent)==JFileChooser.APPROVE_OPTION){
		java.io.File fil = fc.getSelectedFile();
		if (!fil.getName().toLowerCase().endsWith(".tex")){
		    String fname=fil.getName()+".tex";
		    fil=new java.io.File(fil.getParent(), fname);
		}
		String warning = (fil.exists()?
				  StringX.replace(AdabaShared.getLabel("WarningOverwriteDB"),
						  "%s", fil.getName()):
				  StringX.replace(AdabaShared.getLabel("WarningSaveDB"),
						  "%s", fil.getName()));

		if (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(
						      parent,
						      warning,

						      AdabaShared.getLabel("TitleExportTIPA"),
						      JOptionPane.YES_NO_OPTION,
						      JOptionPane.WARNING_MESSAGE)){
                    at.iem.adaba.database.TIPA.TIPAfile tipafile=new  at.iem.adaba.database.TIPA.TIPAfile(fil);
                    try {
                        boolean ok=tipafile.exportFrom(dataBase);
                        at.iem.tools.Logger.println("exported: "+ok);
                    } catch (Exception ex) {
                        at.iem.tools.Logger.println("an error occured: "+ex);
                    }
		    //dataBase.exportTIPA(fil, true); //  "true"==sorted; "false"=unsorted
		    JOptionPane.showMessageDialog(parent,  
						  AdabaShared.getLabel("MessageExported"));
		}
	    }
	} else if (cmd.equals("exportSAMPA")){
	    JFileChooser fc = new JFileChooser(".");
	    fc.setFileFilter(new at.iem.tools.gui.CustomFileFilter(AdabaShared.getLabel("FileSAMPA"), ".txt"));
	    if (fc.showSaveDialog(parent)==JFileChooser.APPROVE_OPTION){
		java.io.File fil = fc.getSelectedFile();
		if (!fil.getName().toLowerCase().endsWith(".txt")){
		    String fname=fil.getName()+".txt";
		    fil=new java.io.File(fil.getParent(), fname);
		}
		String warning = (fil.exists()?
				  StringX.replace(AdabaShared.getLabel("WarningOverwriteDB"),
						  "%s", fil.getName()):
				  StringX.replace(AdabaShared.getLabel("WarningSaveDB"),
						  "%s", fil.getName()));

		if (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(
						      parent,
						      warning,
						      AdabaShared.getLabel("TitleExportSAMPA"),
						      JOptionPane.YES_NO_OPTION,
						      JOptionPane.WARNING_MESSAGE)){
		    Object[] possibilities = new Object[AdabaShared.region.length+1];
		    possibilities[0]=AdabaShared.getLabel("LabelStandardTranscription");
		    for (int i=1; i<possibilities.length; i++)possibilities[i]=AdabaShared.region[i-1][1];
		    String s = (String)JOptionPane.showInputDialog(
					parent,
					AdabaShared.getLabel("MessageExportSampaRegion"),
					AdabaShared.getLabel("MessageSampaRegionTitle"),
					JOptionPane.PLAIN_MESSAGE,
					null,
					possibilities,
					AdabaShared.getLabel("LabelStandardTranscription"));
		
		    //If a string was returned, say so.
		    if(s==null || "".equals(s))s="";
                    String index=null;
		    for (int i=0; i<AdabaShared.region.length; i++)
			if(s.equals(AdabaShared.region[i][1])){
                            index=AdabaShared.region[i][0];
			    break;
			}
		    dataBase.exportSAMPA(fil, index);
		}
	    }
	} else if (cmd.equals("exportTEXT")){
	    JFileChooser fc = new JFileChooser(".");
	    fc.setFileFilter(new at.iem.tools.gui.CustomFileFilter(AdabaShared.getLabel("FileTXT"), ".txt"));
	    if (fc.showSaveDialog(parent)==JFileChooser.APPROVE_OPTION){
		java.io.File fil = fc.getSelectedFile();
		if (!fil.getName().toLowerCase().endsWith(".txt")){
		    String fname=fil.getName()+".txt";
		    fil=new java.io.File(fil.getParent(), fname);
		}
		String warning = (fil.exists()?
				  StringX.replace(AdabaShared.getLabel("WarningOverwriteDB"),
						  "%s", fil.getName()):
				  StringX.replace(AdabaShared.getLabel("WarningSaveDB"),
						  "%s", fil.getName()));

		if (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(
						      parent,
						      warning,
						      AdabaShared.getLabel("TitleExportTXT"),
						      JOptionPane.YES_NO_OPTION,
						      JOptionPane.WARNING_MESSAGE)){
                    at.iem.adaba.database.TXT.TXTfile txtfile=new  at.iem.adaba.database.TXT.TXTfile(fil);
                    try {
                        boolean ok=txtfile.exportFrom(dataBase);
                        at.iem.tools.Logger.println("exported: "+ok);
                    } catch (Exception ex) {
                        at.iem.tools.Logger.println("an error occured: "+ex);
                    }
		}
	    }
	} else if (cmd.equals("import")){
	    JFileChooser fc = new JFileChooser(".");
	    fc.setFileFilter(new at.iem.tools.gui.CustomFileFilter(AdabaShared.getLabel("FileATD"),
							       ".atd"));
	    fc.setMultiSelectionEnabled(true);
	    boolean importOnlyValid=true;
	    if (fc.showOpenDialog(parent)==JFileChooser.APPROVE_OPTION){
		/* we should ask for some properties, concerning the merge:
		 * a) only import "edited" entries
		 * b) timestamping: 
		 * b1) only import "newer" entries +
		 * b2) ignore timestamping (never overwrite) +
		 * b3) ignore timestamping (always overwrite) +
		 * b4) ignore timestamping (create alternative enry) +
		 */
		ImportOptions imop = new ImportOptions();
		String[] clashes = dataBase.importATD(fc.getSelectedFiles(), 
                                                                    imop.onlyEdited(), 
                                                                    imop.mergeMode(),
                                                                    imop.storeAsAlternate());
		if(clashes!=null && clashes.length>0){
		    parent.clearSet(clashes, -1);
		}
	    }
	} else if (cmd.equals("importXML")){
	    JFileChooser fc = new JFileChooser(".");
	    fc.setFileFilter(new at.iem.tools.gui.CustomFileFilter(AdabaShared.getLabel("FileXML"),
							       ".xml"));
	    if (fc.showOpenDialog(parent)==JFileChooser.APPROVE_OPTION){
                try {
                    boolean overwrite=true;
                    at.iem.adaba.database.XML.XMLfile xmlfile=new  at.iem.adaba.database.XML.XMLfile(fc.getSelectedFile());
                    //String[] clashes=dataBase.importXML(fc.getSelectedFile());
                    String[] clashes=xmlfile.importTo(dataBase, overwrite);
                    if(clashes!=null && clashes.length>0){
                        parent.clearSet(clashes, -1);
                    }

                } catch (Exception ex) {
                }


	    }
	} else if (cmd.equals("entryinsert")){
	    String newentry = JOptionPane.showInputDialog(parent,
							  AdabaShared.getLabel("MessageEntryNew"),
							  AdabaShared.getLabel("TitleEntryNew"),
							  JOptionPane.QUESTION_MESSAGE);
	    if (newentry!=null && newentry.length()>0){
		TranscriptionEintrag entry= new TranscriptionEintrag(newentry);
                dataBase.startAsync();
		if (null==dataBase.add(entry)) {
                    at.iem.tools.Logger.println("neueintrag failed!");
		} else {
                    dataBase.stopAsync();
		    parent.show(newentry);
		}
                dataBase.stopAsync();
	    }
	} else if (cmd.equals("entrydelete")){
	    parent.singleDelete();
	} else if (cmd.equals("entrysdelete")){
		parent.selectedDelete();
	} else if (cmd.equals("entrysexport")){
 	    parent.selectedExport();
	} else if (cmd.equals("entrysexportSAMPA")){
 	    parent.selectedExportSAMPA();
	} else if (cmd.equals("about")){
	    new GnuGPL(true);
	} else if (cmd.equals("sampa")){
	    new AdabaSAMPAhelp();
	} else if (cmd.equals("properties")){
	    new TransProperties();
	    parent.refresh();
	} else if (cmd.equals("extendedsearch")){
      AdabaShared.TranscriberSearch=true;
	    parent.refresh();
	} else {
	    at.iem.tools.Logger.println("I do not know, what to do!!!!");
	}
    }

    /**
     * a class for setting the options when importing a TranscriptionDataBase into another one
     * LATER: move this to adaba/database/ (???)
     */
    class ImportOptions extends JDialog  implements ActionListener{
	JCheckBox editedBut, altBut;
	JRadioButton[] mergeBut = new JRadioButton[3];
	JButton doneBut;
	public ImportOptions(){
	    setModal(true);
	    setTitle(AdabaShared.getLabel("ImportDBTitle"));
	    JPanel masterPane = new JPanel(new BorderLayout());
	    JPanel mergePane = new JPanel(new GridLayout(0,1));

	    editedBut = new JCheckBox(AdabaShared.getLabel("ImportDBButtonEdit"));
	    editedBut.setSelected(true);
	    masterPane.add(editedBut, BorderLayout.NORTH);

	    ButtonGroup mergeGroup = new ButtonGroup();
	    for (int i=0; i<mergeBut.length; i++){
		mergeBut[i] = new JRadioButton(AdabaShared.getLabel("ImportDBButtonMerge"+i));
		mergeGroup.add(mergeBut[i]);
		mergePane.add(mergeBut[i]);
	    }
	    mergeBut[0].setSelected(true);

	    altBut = new JCheckBox(AdabaShared.getLabel("ImportDBButtonStoreAlt"));
	    altBut.setSelected(true);
	    mergePane.add(altBut);

	    masterPane.add(mergePane, BorderLayout.CENTER);

	    doneBut = new JButton(AdabaShared.getLabel("ImportDBButtonOK"));
	    doneBut.addActionListener(this);

	    masterPane.add(doneBut, BorderLayout.SOUTH);

	    getContentPane().add(masterPane);
	    pack();
	    setVisible(true);
	}
        /**
         * query whether only entries which are flagged "done" should be imported
         * @return <code>true</code> if only "done" entries are to be imported, <code>false</code> if <b>all</b> entries are to be imported
         */
	public boolean onlyEdited(){
	    return editedBut.isSelected();
	}
        /**
         * query, how duplicate entries should be merged into the new database
         * return <ul><li><code>0</code> keep original entry</li><li><code>1</code> keep new entry</li><li><code>2</code> use the new entry if it is newer than the original one</li></ul>
         */
	public int mergeMode(){
	    for (int i=0; i<mergeBut.length; i++)
		if(mergeBut[i].isSelected())return i;
	    return -1;
	}
        /**
         * query whether duplicate entries should be stored as alternative words (this is: 2 independent entries with the same key)
         * @return <code>true</code> if 2 separate entries should be made for the conflicting entries
         */
	public boolean storeAsAlternate(){
	    return altBut.isSelected();
	}
        /**
         * whenever the user has clicked "ok"
         */
	public void actionPerformed(ActionEvent e) {
	    dispose();
	}

	/* for serialization */
	private static final long serialVersionUID = 1L;
    }

    /* for serialization */
    private static final long serialVersionUID = 1L;

}
