// FileFilterRegex.java
// $Id: FileFilterRegex.java 512 2004-03-08 19:10:57Z zmoelnig $
// Institute for Electronic Music and Acoustics, Graz (IEM)
//
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

// eXtended String-operations

package at.iem.tools;
import java.io.File;
import java.util.regex.*;

public class FileFilterRegex implements java.io.FilenameFilter {
    java.util.regex.Matcher matcher;
    boolean check_dirs;
  
    public FileFilterRegex(String filter, boolean checkdirs, boolean case_sensitive) {
	java.util.regex.Pattern pattern;
        check_dirs=checkdirs;
        int flags=0;
        if(case_sensitive)flags=java.util.regex.Pattern.CASE_INSENSITIVE;
	try {
	    pattern = java.util.regex.Pattern.compile(filter, flags);
            matcher=pattern.matcher("");
	} catch(PatternSyntaxException ex){
            matcher=null;
	}
    }

    public boolean accept(File path, String file) {
        if(!check_dirs) {
            File f = new File(path, file);
            if(f.isDirectory())return true;
        }
        if(matcher==null)return false;
        matcher.reset(file);
        return matcher.matches();
    }


}
