// Logger.java
// $Id: Logger.java 804 2005-03-01 22:57:31Z zmoelnig $
// Institute for Electronic Music and Acoustics, Graz (IEM)
//
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

// debugging output String-operations

package at.iem.tools;

public class Logger {
    private static java.io.OutputStreamWriter logstream=null;
    private static String lineEnd="\n";
    private static java.text.DateFormat date;

    private static java.io.PrintStream printstream;

    public static void setLogfile(java.io.File file) {
        if(null==file) {
            logstream=null;
            return;
        }

        try {
            java.io.FileOutputStream ostr = new java.io.FileOutputStream(file); 
	    logstream = new java.io.OutputStreamWriter(ostr, "UTF-8");
            printstream = new java.io.PrintStream(ostr);
            java.lang.System.setOut(printstream);
            java.lang.System.setErr(printstream);
        } catch (Exception ex) {
            System.err.println("log: couldn't open logfile '"+file+"' for writing");
        }
        date=java.text.DateFormat.getDateTimeInstance(java.text.DateFormat.SHORT, java.text.DateFormat.LONG);
        lineEnd=System.getProperty("line.separator");
    }

    public static void println(Object s) {
        //System.err.println("log: "+s);
        if(logstream!=null) {
            try {
                logstream.write(date.format(new java.util.Date())+": "+s.toString());
                logstream.write(lineEnd);
                logstream.flush();
           } catch (Exception ex) {
                System.err.println("log: couldn't write to logfile");
            }
        }
    }
    public static void println(String s) {
        //System.err.println("log: "+s);
        if(logstream!=null) {
            try {
                logstream.write(date.format(new java.util.Date())+": "+s);
                logstream.write(lineEnd);
                logstream.flush();
            } catch (Exception ex) {
                System.err.println("log: couldn't write to logfile");
            }
        }
    }
    private static int vlevel = 0;
    public static void println(int level, String s) {
        if(vlevel<level)println(s);
    }
}

