// Selectable.java
// $Id: Selectable.java 831 2006-03-16 16:21:53Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

package at.iem.tools;

/**
 * interface for things who can select something
 */
public interface Selectable {

    /** 
     * get the index of the selected item
     */
    public int getSelectedIndex();

    /**
     * get the entire selection
     */
    public Object[] getSelection();


    /** 
     * set the index of the selected item
     */
    public void setSelectedIndex(int id);

    /** 
     * select an item by name
     */
    public void setSelected(String id);
}
