// StringX.java
// $Id: StringX.java 1715 2007-06-12 12:05:12Z zmoelnig $
// Institute for Electronic Music and Acoustics, Graz (IEM)
//
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

// eXtended String-operations

package at.iem.tools;

public class StringX {
    public static String replace(String parent, String oldName, String newName) {
	/* replace a whole substring by another */

	if (parent.length()==0)return parent;
	if (oldName.length()==1 && newName.length()==1){
	    return parent.replace(oldName.charAt(0), newName.charAt(0));
	}
	/*
	StringBuffer process = new StringBuffer (parent);
	int lnge = parent.length();
	int oldLnge = oldName.length();
	int newLnge = newName.length();
	int i = 0;
	while(i<(lnge-oldLnge+1)) {
	    String substri = process.substring(i,i+oldLnge);
	    if (substri.compareTo(oldName)==0){
		StringBuffer process2 = process.replace(i, i+oldLnge, newName);
		process = process2;
		i=i+newLnge;
		lnge=process.length();
	    }
	    i=i+1;
	}
	return process.toString();
	*/
	int s = 0;
        int e = 0;
        StringBuffer result = new StringBuffer();
	while ((e = parent.indexOf(oldName, s)) >= 0) {
            result.append(parent.substring(s, e));
            result.append(newName);
            s = e+oldName.length();
        }
        result.append(parent.substring(s));
        return result.toString();
    }


    public static String replace(String parent, String oldName[], String newName) {
	/* replace a bunch of substrings by one other String */

	if (parent.length()==0)return parent;
	if (oldName==null || oldName.length<1)return parent;

	String result= new String(parent);

	for(int i=0; i<oldName.length; i++)
	    result=replace(result, oldName[i], newName);

	return result;
    }

    public static String replace(String parent, String repl[][]){
	if (parent==null  || parent.length()==0)return parent;
	if (repl==null    || repl.length<1)return parent;
	if (repl[0].length!=2)return null;

	StringBuffer parentSB = new StringBuffer(parent);
	StringBuffer result = new StringBuffer(parent.length());

	boolean found=false;

	for(int i=0; i<parent.length();){
	    found=false;
	    for(int j=0; j<repl.length; j++){
		if (parent.startsWith(repl[j][0], i)){
		    result.append(repl[j][1]);
		    i+=repl[j][0].length();
		    found=true;
		    break;
		}
	    }
	    if(!found)result.append(parentSB.charAt(i++));
	}
	return result.toString();


    }

    public static String replace(String parent, String oldName[], String newName[]) {
	if (parent==null  || parent.length()==0)return parent;
	if (oldName==null || oldName.length<1)return parent;
	if (newName==null || newName.length!=oldName.length)return parent;
	if (false){
	String result= new String(parent);

	for(int i=0; i<oldName.length; i++)
	    result=replace(result, oldName[i], newName[i]);
	
	return result;
	}

	StringBuffer parentSB = new StringBuffer(parent);
	StringBuffer result = new StringBuffer(parent.length());

	boolean found=false;

	for(int i=0; i<parent.length();){
	    found=false;
	    for(int j=0; j<oldName.length; j++){
		if (parent.startsWith(oldName[j], i)){
		    result.append(newName[j]);
		    i+=oldName[j].length();
		    found=true;
		    break;
		}
	    }
	    if(!found)result.append(parentSB.charAt(i++));
	}
	return result.toString();
    }


    public static String toXML(String s) {
	/* make the string XML-conform : eg replace "&" by "&amp;" */
	String x = replace(s, "&", "&amp;");
	x = replace(x, "<", "&lt;");
	x = replace(x, ">", "&gt;");
	x = replace(x, "'", "&apos;");
	x = replace(x, "\"", "&quot;");

	return x;
    }

    public static String fromXML(String s) {
	/* make an  XML-conformant string "normal" again : eg replace "&amp;" by "&;" */
	String x = replace(s, "&lt;", "<");
	x = replace(x, "&gt;", ">");
	x = replace(x, "&amp;", "&");
	x = replace(x, "&apos;", "'");
	x = replace(x, "&quot;", "\"");
	return x;
    }

    public static byte[] getBytesUTF8(String s) {
	if (s==null)return null;
	byte[] buf;
	try {
	    buf=s.getBytes("UTF-8");
	} catch (Exception ex) {
	    buf=s.getBytes();
	}
	return buf;
    }
    public static String fromBytesUTF8(byte[] b) {
	if (b==null)return null;
	String s;
	try {
	    s=new String(b, "UTF-8");
	} catch (Exception ex) {
	    s=new String(b);
	}
	return s;
    }

    public static boolean contains(String[] haystack, String needle){
	if(haystack==null || haystack.length<1)return false;

	int length = haystack.length;
	for(int i=0; i<length; i++)
	    if (needle.equals(haystack[i]))return true;

	return false;
    }

    public static String merge(String[] array, String delimiter){
	if(array==null || array.length<1)return null;
	StringBuffer result = new StringBuffer(array[0]);

	for (int i=1; i<array.length;i++)result.append(delimiter+array[i]);

	return (result.toString());
    }
    public static String merge(String[] array){
	return merge(array, "");
    }

    public static String[] concatenate(String[][]arrays){
	int count=0;

	for(int i=0; i<arrays.length; i++)count+=arrays[i].length;

	String[]ret=new String[count];
	count=0;
	for(int i=0; i<arrays.length; i++)
	    for(int j=0; j<arrays[i].length; j++){
		ret[count]=new String(arrays[i][j]);
		count++;
	    }
	return ret;
    }


    public static String trimBlanks(String s){
        s=s.replaceAll("^[ \t]*", "");
        s=s.replaceAll("[ \t]*$", "");
        return s;
    }
}

