// AntiAliasing.java
// $Id: AntiAliasing.java 1855 2007-07-03 08:41:44Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file



package at.iem.tools.gui;

import javax.swing.*;
import java.awt.RenderingHints;
import java.awt.Toolkit;
import java.util.Map;
import java.awt.Graphics2D;
import java.awt.Graphics;


public abstract class AntiAliasing {
    private AntiAliasing() {}

    static final RenderingHints aaHints = new RenderingHints(java.awt.RenderingHints.KEY_TEXT_ANTIALIASING, java.awt.RenderingHints.VALUE_TEXT_ANTIALIAS_ON);

    static
    {
        Map desktopHints = (Map)Toolkit.getDefaultToolkit()
            .getDesktopProperty("awt.font.desktophints");
        if (desktopHints != null)
            {
                aaHints.putAll(desktopHints);
            }
    }

    public static void enable(javax.swing.JComponent c) {
        Graphics g=c.getGraphics();
        if (aaHints != null && (g instanceof Graphics2D))
            {
                ((Graphics2D)g).addRenderingHints(aaHints);
            }
    }
}
