/*
 * AbstractPlayerEvent
 * 
 * (c) Copyright IOhannes m zmlnig
 * Institute for Electronic Music and Acoustics, Graz (IEM)
 *
 *-----------------------------------------------------------------------
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License as published
 *   by the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *----------------------------------------------------------------------
 */

package at.iem.tools.sound;

public class AbstractPlayerEvent
{
    public static final int UNKNOWN = -1;
    public static final int OPENING = 0;
    public static final int OPENED = 1;
    public static final int PLAYING = 2;
    public static final int STOPPED = 3;
    public static final int PAUSED = 4;
    public static final int RESUMED = 5;
    public static final int SEEKING = 6;
    public static final int SEEKED = 7;
    public static final int EOM = 8;
    public static final int PAN = 9;
    public static final int GAIN = 10;


    private int code = UNKNOWN;
    /**
     * Constructor
     * @param code of the envent
     */
    public AbstractPlayerEvent(int code) {
        this.code  =code;
    }

    /**
     * Return code of the event triggered.
     * @return
     */
    public int getCode()
    {
        return code;
    }
}
