// AbstractPlayerStateListener.java
// $Id: AbstractPlayer.java 922 2006-05-16 20:09:42Z zmoelnig $
// (c) Copyright IOhannes m zm-blnig-A
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the Gnu-General Public License
// see the LICENSE.txt file

package at.iem.tools.sound;

/**
 * This interface defines callbacks methods that will be notified
 * for all registered AbstractPlayerStateListeners of AbstractPlayer.
 */
public interface AbstractPlayerStateListener {
    /**
     * Notification callback for basicplayer events such as playing, pause, stopped,...
     *  
     * @param event
     */
    public void stateUpdated(Object source, AbstractPlayerEvent event);
}
