// MP3Player.java
// $Id: MP3Player.java 824 2005-11-15 15:57:49Z zmoelnig $
// (c) Copyright IOhannes m zmlnig
// Institute for Electronic Music and Acoustics, Graz (IEM)
// 
// this code is licensed under the GNU General Public License (GnuGPL)
// see the LICENSE.txt file
//
// as a matter of facts, this code has just been ripped off the JavaLayer-0.2-Player jlp
//
// (c) Mat McGowan
// you can find JavaLayer at http://javalayer.sourceforge.net
// (thanks goodness, these gals released Javalayer under GnuGPL

package at.iem.tools.sound;

import javazoom.jl.player.*;
import javazoom.jl.decoder.JavaLayerException;

import java.io.*;
import java.net.*;

public class MP3Player extends at.iem.tools.sound.AbstractPlayer implements Runnable {
    private Thread	playerThread = null;	

    private Player player = null;
    private AudioDevice dev = null;

    private static boolean isFirstTime=true;
    private static void firstTime(){
	if (isFirstTime){
	    System.out.println("\tMP3Player by zmoelnig@iem.at");
	    System.out.println("\tusing JavaLayer 0.2.0 by javazoom");
	    System.out.println("\thttp://www.javazoom.net/javalayer/javalayer.html");
	    isFirstTime=false;
	}
    }

    public MP3Player(){ firstTime(); }

    public boolean play() {
	InputStream in = getAudioStream();
	try {			
	    AudioDevice l_dev = FactoryRegistry.systemRegistry().createAudioDevice();
	    do_play(in, l_dev);
	}catch (JavaLayerException ex)	{
	    synchronized (System.err)	{
		System.err.println("Unable to play "+SoundFile);
		ex.printStackTrace(System.err);
		return false;
	    }
	}
	return true;
    }

    protected InputStream getAudioStream(){
	InputStream in = null;
	try	{
	    if (SoundFile!=null)			
		in = SoundFile.openStream();
	}catch (IOException ex){
	    System.err.println(ex);
	}
	return in;
    }
    public boolean pause(){
	if (player!=null)   {
	    player.close();
	    player = null;
	    playerThread = null;
	}
	return true;
    }
    protected void do_play(InputStream in, AudioDevice dev) throws JavaLayerException   {
	pause();
	//System.out.println("DO PLAY");
	
	if (in!=null && dev!=null){
	    player = new Player(in, dev);
	    playerThread = createPlayerThread();
	    playerThread.start();
	}
    }
    protected Thread createPlayerThread(){
	return new Thread(this, "Audio player thread");	
    }

    public void run(){				
	if (player!=null){
	    try	{
		player.play();				
	    }catch (JavaLayerException ex){
		System.err.println("Problem playing audio: "+ex);
	    }			
	}
    }

    public void start()	{ // start applet
	//System.out.println("start thread!");
	try {			
	    InputStream in = getAudioStream();
	    AudioDevice l_dev = FactoryRegistry.systemRegistry().createAudioDevice();
	    do_play(in, l_dev);
	}catch (JavaLayerException ex)	{
	    synchronized (System.err)	{
		System.err.println("Unable to play "+SoundFile);
		ex.printStackTrace(System.err);
	    }
	}
    }	
    
    public void stop(){ // stop applet
	pause();
    }
    
}
